
function assemble2,mastername,slavelist,scl=scl

 slavenames = loadlist(slavelist)
 nimages = n_elements(slavenames)+1
 names = replicate(mastername,nimages)
 names[1] = temporary(slavenames)

;initialize image and mask pointers, and arrays for offsets and medians
 images = replicate(ptr_new(0),nimages)
 masks = replicate(ptr_new(0),nimages)
 offsets = fltarr(4,nimages)
 meds = fltarr(nimages)

;read in images and masks and get offsets to master
 for i = 0,nimages-1 do begin
  fits_datmask,names[i],*images[i],hdr,mask
  (*images[i])[mask] = 0
  meds[i] = median((*images[i])[where(*images[i] ne 0)])
  sz = size(*images[i])
  if i gt 0 then begin
   flg = i-1 > 0
   offsets[0:1,i] = rob_reg(*images[0],*images[i],scl=scl,coadd=flg)
   offsets[2:3,i] = [sz[1]-msz[1],sz[2]-msz[2]]
  endif else msz = sz 
 endfor

;find the lower left corner
 newbase = [min(offsets[0,*])<0,min(offsets[1,*])<0] 

;change offsets to make that [0,0]
 offsets[0:1,*] = temporary(offsets[0:1,*]) - newbase

;now find upper right corner
 limits = [fix(max(offsets[0,*]+offsets[2,*])+msz[1]+1),fix(max(offsets[1,*]+$
           offsets[3,*])+msz[2]+1)]

;expand images and masks 
 for i = 0,nimages-1 do begin
  temp = make_array(limits[0],limits[1],type=msz[msz[0]+1])
  temp[fix(offsets[0,i]+.5),fix(offsets[1,i]+.5)] = temporary(*images[i])
  *masks[i] = where(temp eq 0)
  *images[i] = temporary(temp) - meds[i] + meds[0]
  (*images[i])[*masks[i]] = 0
 endfor

;update offsets for subpixel shifts.
 offsets[0:1,*] = offsets[0:1,*] - fix(offsets[0:1,*]+.5)

;here is where we branch off...  We can either take the masked median of the 
;cube that has yet to be formed or we can apply the subpixel shifts in order
;to take the mask-weighted mean (note that we need to make mask images and
;shift those as well!).   

;median method
 med3d = ptr_new(0)
 *med3d = masked_median(images)

 for i = 0,nimages-1 do begin
  temp = *images[i] - *med3d
  mo = moment(temp,sdev=sd) & mmo = moment(temp[where(temp ne 0)],sdev=msd)
  med = median(temp) & mmed = median(temp[where(temp ne 0)])
  print,'WITH MASK PIXELS:'
  print,'     Mean: '+mo[0]+' Std Dev: '+sd+' Median: '+med
  print,'WITHOUT MASK PIXELS:'
  print,'     Mean: '+mmo[0]+' Std Dev: '+msd+' Median: '+mmed
  window,0,xs=limits[0],ys=limits[1]
  tvscl,temp>0<100
  ok = dialog_message(/info,"How's it look?")
 endfor

 return,*med3d

end
