pro ch_hdr,old,new,key,dirname=dirname

;get dirname if not provided
 if not keyword_set(dirname) then dirname=dialog_pickfile(/directory,$
    title='Select a directory with images that need header correction')
 if dirname eq '' then begin
  print,'ERROR in ch_hdr.pro: No directory specified!'
  retall
 endif

;get filenames
 f = findfile(dirname+'*?.?*',count=nf)
 if nf eq 0 then begin
  print,'ERROR in ch_hdr.pro: No files of that specification!!'
  retall
 endif

;read in images and correct those that need it
 for i = 0,nf-1 do begin

  fits_read,f[i],im,hdr
  if fits_str(key,hdr) eq old then begin
   print,'Correcting '+key+' entry in '+f[i]+'...'
   hdr = fits_sub(new,key,hdr)
   fits_write,f[i],im,hdr
  endif else print,'Skipping '+f[i]+'...'

 endfor

end
