
pro dawn_remosaic,infiles,xoffsets,yoffsets,outfile,chopsig=chopsig

  if not keyword_set(chopsig) then chopsig=3

  f = infiles 
  nmos = n_elements(f)
  xoff = xoffsets
  yoff = yoffsets
  r = 0

  for j = 0,nmos-1 do begin
;   if stat[i,j] eq 1 then begin
;    fits_datmask,f[i,j],slave,hdr,mask,/no_vect
    fits_datmask,f[j],slave,hdr,mask,/no_vect

    if mask[0] eq -1 then begin
     mask = finite(slave)
     w = where(mask eq 0,nbd)
     if nbd gt 0 then slave[w] = 0
     w = where(mask eq 1,ngd2)
     if ngd2 gt 0 then w2 = where(slave[w] le 0,nbd) else nbd = 0
     if nbd gt 0 then begin
      mask[w[w2]] = 0
      slave[w[w2]] = 0
     endif
    endif

    if n_elements(master) eq 0 then begin
     sz=size(slave) & ngd = n_elements(infiles);w=where(stat[i,*] eq 1,ngd)
     imcube = fltarr(sz[1]+2,sz[2]+2,ngd)
     maskcube = fltarr(sz[1]+2,sz[2]+2,ngd)
     meds = fltarr(ngd)
     wbd = where(mask lt .1,nbd)
     if nbd gt 0 then slave[wbd] = 0
     if nbd gt 0 then mask[wbd] = 0
     imcube[1:sz[1],1:sz[2],0] = slave
     maskcube[1:sz[1],1:sz[2],0] = mask
     meds[0] = median(slave[where(mask gt 0)])
;     meds[0] = median(slave[150:250,150:250])
     master = slave
     mastermask = mask
     masterhdr = hdr
    endif else begin
     wbd = where(mask lt .1,nbd)
     if nbd gt 0 then slave[wbd] = 0
     if nbd gt 0 then mask[wbd] = 0
     imcube[1:sz[1],1:sz[2],r] = slave
     maskcube[1:sz[1],1:sz[2],r] = mask
     meds[r] = median(slave[where(mask gt 0)])
;     meds[r] = median(slave[150:250,150:250])
     mosaic_two,master,mastermask,slave,mask,xoff[r],yoff[r],xmoff,ymoff,/autoffset
     xoff = xoff+xmoff
     yoff = yoff+ymoff
    endelse
    r = r+1
;   endif
;  erase&tvimage,bytscl(master,min=0,max=4),/keep
  endfor

;  window,0,xs=800,ys=800

;stop

  erase&tvimage,bytscl(master,min=0,max=200),/keep

  sz2 = size(master)
  imcube2 = fltarr(ngd,sz2[1],sz2[2])
  maskcube2 = fltarr(sz2[1],sz2[2],ngd)

  xoff2 = fix(xoff+.99) & yoff2 = fix(yoff+.99)

  imcube = imcube*maskcube

  for j = 0,ngd-1 do begin
   if (xoff[j]-1.*fix(xoff[j]) gt .01) then xoff[j] = xoff2[j]*1.-xoff[j] else xoff[j]=0.
   if (yoff[j]-1.*fix(yoff[j]) gt .01) then yoff[j] = yoff2[j]*1.-yoff[j] else yoff[j]=0.
   imcube2[j,xoff2[j]-1:xoff2[j]+sz[1],yoff2[j]-1:yoff2[j]+sz[2]] = interp(reform(imcube[*,*,j]),xoff[j],yoff[j])
   maskcube2[xoff2[j]-1,yoff2[j]-1,j] = interp(reform(maskcube[*,*,j]),xoff[j],yoff[j])
   wbd = where(maskcube2[*,*,j] lt .1,nbd)
   if nbd gt 0 then begin
    tmp = maskcube2[*,*,j]
    tmp[wbd] = 0
    maskcube2[*,*,j] = tmp
    wgd = where(maskcube2[*,*,j] ge .1)
    tmp = reform(imcube2[j,*,*])
    tmp[wgd] = tmp[wgd]/(maskcube2[*,*,j])[wgd] - (meds[j]-meds[0])
    tmp[wbd] = !values.f_nan
    imcube2[j,*,*] = tmp
   endif
  endfor

  imcube = imcube[1:sz[1],1:sz[2],*]
  maskcube = maskcube[1:sz[1],1:sz[2],*]

;  ictot = total(imcube2,3)
  ictot = reform(median_stack2(imcube2))
  mctot = total(maskcube2,3)

  wbd = where(mctot lt .1,nbd)
;  ictot[wbd] = .00001 & mctot[wbd] = 1
;  ictot = ictot/mctot
  
  avg = ictot
  std = sqrt(avg>0)
  erase&tvimage,bytscl(ictot,min=0,max=200),/keep

  xoff = xoffsets & yoff = yoffsets
  for j = 0,ngd-1 do begin
   inmask = where(maskcube[*,*,j] lt .1,numbad)
   mask = where(maskcube2[*,*,j] lt .1);*mask_ptrs[i]
   im = reform(imcube2[j,*,*])
   im[mask]=-10000
   wgood = where(im ne -10000,ngood)
   im[mask]=0.
   im[wgood] = im[wgood]/(maskcube2[*,*,j])[wgood]
  ; if ngood gt 0 then begin
    check = (im-avg) / (std>0.000001)

;replicate skysclim.pro with mask included
    idx=randomu(seed,min([1000,n_elements(im)-numbad]))*(n_elements(im)-numbad-1)
    robomean,check[wgood[idx]],2.0,0.5,meanval,dummy,rsig
;and pray that this works...

;flagging condition
    check = temporary(check)/rsig
    wbd = where(check gt chopsig,nbd)
    
; stop

   if nbd gt 0 then begin
    xbd = (wbd mod sz2[1]) - xoff2[j] + round(xoff[j])
    ybd = (wbd / sz2[1]) - yoff2[j] + round(yoff[j])
    w2 = where(xbd ge 0 and xbd le sz[1]-1 and ybd ge 0 and ybd le sz[2]-1,n2)
    if n2 gt 0 then begin
     newmask = ybd[w2]*sz[1]+xbd[w2]
     inmask = merge_mask(newmask,inmask)
     print,'Filtered Pixels:',n_elements(inmask) - numbad
    endif
   endif
   fits_datmask,infiles[j],im,hdr,oldmask
   mask = im*0+1&mask[inmask] = 0&inmask=mask
   if j eq 0 then begin
    master = im
    mmask = inmask
    mhdr = hdr   
   endif else begin
    mosaic_two,master,mmask,im,inmask,xoff[j],yoff[j],xmoff,ymoff,/autoffset
    xoff = xoff+xmoff
    yoff = yoff+ymoff
   endelse
  endfor

  fits_datmask,/write,outfile,master,mhdr,mmask

;  erase&tvimage,bytscl(ictot,min=0,max=200),/keep
  
end
