;+
;
;quick_tweak
;
;for distortion correcting and/or mask updating a bunch of images
;
;-

pro quick_tweak,addmask=addmask,polywarp_x=polywarp_x,polywarp_y=polywarp_y,$
	chopmask=chopmask

 if strlowcase(!version.os_family) eq 'windows' then sls = '\' else sls = '/'

 infiles = dialog_pickfile(/mult,title='Select FITS files to be tweaked')
 dir = dialog_pickfile(/dir,title='Select directory for tweaked files')

 if infiles[0] eq '' or dir eq '' then retall
 if not file_test(dir) then file_mkdir,dir

 nf = n_elements(infiles)

 if keyword_set(addmask) or keyword_set(chopmask) then mflg = 1 else mflg = 0
 if keyword_set(polywarp_x) and keyword_set(polywarp_y) then pflg=1 else pflg=0

 if mflg or pflg then begin
  for i=0,nf-1 do begin
   print,'Reading '+infiles[i]
   fits_datmask,infiles[i],im,hdr,inmask

   if mflg then begin
    print,'Updating mask'
    nin = n_elements(inmask)
    if keyword_set(addmask) then inmask = merge_mask(temporary(inmask),addmask)
    if keyword_set(chopmask) then begin
     tmpim = im
     tmpim[inmask] = median(im)
     w = where(tmpim lt 0 or tmpim gt 1.e5,nw)
     if nw gt 0 then inmask = merge_mask(temporary(inmask),w)
    endif
    nw = n_elements(inmask) - nin
    if nw gt 0 then sxaddpar,hdr,'HISTORY',systime(/utc)+' UTC: '+strtrim(nw,2)$
       +' bad pixels added to badpix vector'
   endif

   if pflg then begin
    print,'Applying polywarp'
    newmask = im * 0. + 1.
    if inmask[0] ne -1 then newmask[inmask] = 0
    im = temporary(im) * newmask
    im = poly_2d(temporary(im),polywarp_x,polywarp_y,1,missing=0)
    newmask = poly_2d(temporary(newmask),polywarp_x,polywarp_y,1,missing=0)
   
    w = where(newmask ge .1,nw)
    if nw gt 0 then im[w] = im[w] / newmask[w]
    med = median(im)
    w = where(newmask lt .1,nw)
    if nw gt 0 then begin
     newmask[w] = 0
     im[w] = med
    endif
    systm = systime(/utc)
    sxaddpar,hdr,'HISTORY',systm+' UTC: distortion corrected'
    sxaddpar,hdr,'HISTORY',systm+' UTC: weight plane replaced badpix vector'
   endif else newmask = inmask

   temp = strsplit(infiles[i],sls,/extract)
   fname = temp[n_elements(temp)-1]
   print,'Writing '+dir+fname
   fits_datmask,/write,dir+fname,im,hdr,newmask
  
  endfor
 endif

end  
