
;+
;
; rob_reassemble2: trying to take offsets and remake mosaics automatically
;                  while detecting and masking cosmic rays...
; 
; shouldn't be too hard, right?  >;-P
;
;-

pro rob_reassemble2,indir=indir,nocrcorr=nocrcorr,chopsig=chopsig,gain=gain

 if not keyword_set(indir) then indir=dialog_pickfile(/must_exist,$
    /directory,title='Select rob_assemble2 mosaic directory')
 
;multi-platform capability
 if strlowcase(!version.os_family) eq 'windows' then sls = '\' else sls = '/'

 if indir eq '' then retall 
 if strmid(indir,strlen(indir)-1,1) ne sls then indir = indir+sls
 restore,indir+'rob_assemble2.sav'

 nf = n_elements(f)
 fsz = size(f)
 nmos = fsz[1] & npm = fsz[2]

;multi-platform capability part two
 if strlowcase(!version.os_family) eq 'windows' then sls2 = '' else $
    if strmid(f[0],0,1) eq sls then sls2 = sls else sls2 = ''

 temp = strsplit(f[0],sls,/extract)
 ntmp = n_elements(temp)
 if ntmp gt 1 then begin
  for i=0l,nf-1 do begin
   temp = strsplit(f[i],sls,/extract)
   ntmp = n_elements(temp)
   f[i] = temp[ntmp-1]
  endfor
 endif
 f = indir+'../'+f
 f2 = f

 workdir = indir
 file_mkdir,workdir+'temp'

 if not keyword_set(nocrcorr) then begin
;  moffall = fltarr(2,npm)
  for l = 0,npm-1 do begin
   j = ind[l]
   wgd = where(rejects[*,j] eq 0b,ngd)

;  for j = 0,ngd-1 do begin
   for i = 0,nmos-1 do begin
    tmp = strsplit(f[i,j],sls,/extract)
    f2[i,j] = workdir+'temp'+sls+tmp[n_elements(tmp)-1]
;    fits_read,f[i,j],im,hdr,/header_only
;    if i eq 0 then begin
;     mhdr = hdr & xoff = fltarr(nmos) & yoff = xoff
;     if j eq 0 then getrot,mhdr,rot1
;     crpix = sxpar(mhdr,'CRPIX*') - 1
;    endif else begin
;     xyxy,hdr,mhdr,crpix[0],crpix[1],xtmp,ytmp
;     xoff[i] = xtmp-crpix[0] & yoff[i] = ytmp-crpix[1]
;    endelse
   endfor

;time to play with the new toy
   wfun = where_overlap(f,xoffsets,yoffsets,j,nfun,rejects=rejects)
   if nfun eq 0 then begin
    wfun2 = wgd+j*nmos
    delvarx,wfun
   endif else begin
    wfun2 = [wgd+j*nmos,wfun]
    wfun = lindgen(nfun)+ngd
   endelse
   xoff = xoffsets[wfun2] - round(xoffsets[wfun2[0]])
   yoff = yoffsets[wfun2] - round(yoffsets[wfun2[0]])

   cosmic_clean,f[wfun2],xoff,yoff,f2[wgd,j],sec_overlap=wfun,$
                chopsig=chopsig,gain=gain,/nodistcorr,/pm;,moff=moff
;   irac_cosmic_clean,f[*,j],xoff,yoff,f2[*,j],chopsig=chopsig
;   moffall[*,j] = moff

  endfor
 endif else begin
  for l = 0,npm-1 do begin
   j = ind[l]
   for i = 0,nmos-1 do begin
    tmp = strsplit(f[i,j],sls,/extract)
    f2[i,j] = workdir+'temp'+sls+tmp[n_elements(tmp)-1]
    if rejects[i,j] eq 0b then begin
     fits_datmask,f[i,j],im,hdr,mask
     fits_datmask,/write,f2[i,j],im,hdr,mask
    endif
   endfor
  endfor
 endelse

; smnm = indir+'submosaic'+strtrim(lindgen(npm),2)+'.fits'
 mainnm = indir+'final_mosaic_clean.fits'

 stat = 1b-rejects
 xoff = xoffsets
 yoff = yoffsets
 xmoff = 0.& ymoff = 0.

; wacky = [0.,0.]

 for l = 0,npm-1 do begin

  j = ind[l]

  wgd = where(stat[*,j] eq 1b,ngd)
;  xoff = reform(xoffsets[wgd,j])
;  yoff = reform(yoffsets[wgd,j])
;  r = 0
;  wacky = wacky + moffall[

  for i = 0,ngd-1 do begin
;   if stat[i,j] eq 1 then begin
   fits_datmask,f2[wgd[i],j],slave,hdr,mask,/no_vect
   if n_elements(master) eq 0 then begin
    master = slave
    mastermask = mask
    masterhdr = hdr
   endif else begin
    txoff = xoff[wgd[i],j];-wacky[0]
    tyoff = yoff[wgd[i],j];-wacky[1]

    irac_spoffset,slave,hdr,mask,kx,ky,txoff,tyoff
    slave = poly_2d(temporary(slave)*mask,kx,ky,1,missing=0)
    mask = poly_2d(temporary(mask),kx,ky,1,missing=0)
    wgd2 = where(mask ge .1,ngd2)
    if ngd2 gt 0 then slave[wgd2] = slave[wgd2]/mask[wgd2]
    wbd = where(mask lt .1,nbd)
    if nbd gt 0 then begin
     slave[wbd] = 0.
     mask[wbd] = 0.
    endif

    delvarx,kx,ky
;    mosaic_two,master,mastermask,slave,mask,xoff[r],yoff[r],xmoff,ymoff,/autoffset
;    mosaic_two,master,mastermask,slave,mask,xoff[wgd[i],j],yoff[wgd[i],j],xmoff,ymoff,/autoffset
    mosaic_two,master,mastermask,slave,mask,txoff,tyoff,xmoff,ymoff,/autoffset
    xoff = xoff+xmoff
    yoff = yoff+ymoff
   endelse
;   r = r+1
;  endif
  endfor

;  print,'writing '+smnm[i]
;  fits_datmask,/write,smnm[i],master,masterhdr,mastermask
;  delvarx,master,mastermask,masterhdr

 endfor

 fits_datmask,/write,mainnm,master,masterhdr,mastermask

end

