
function ss_align,appix,sortem=sortem,scl=scl,moremask=moremask,infiles=infiles

;we're gonna assume some stupid things:
; 1) TCS's all leave an RA and a DEC tag in their fits headers
; 2) Those readouts are correct and indicate the image center position

 if strlowcase(!version.os_family) eq 'windows' then sls='\' else sls='/'

 if not keyword_set(scl) then scl = 1

 if not keyword_set(infiles) then infiles = dialog_pickfile(/multiple,title='Select FITS Files for Slideshow')

 if infiles[0] ne '' then begin
  nf = n_elements(infiles)
  ra = fltarr(nf) & dec = fltarr(nf)

  for i=0,nf-1 do begin
   fits_read,infiles[i],im,hdr,/header_only
   rastr = strsplit(sxpar(hdr,'RA'),':',/extract)
   decstr = strsplit(sxpar(hdr,'DEC'),':',/extract)
   ra[i] = fix(rastr[0])+fix(rastr[1])/60.+float(rastr[2])/3600.
   dec[i] = fix(decstr[0])+fix(decstr[1])/60.+float(decstr[2])/3600.
  endfor

 ;convert to flamingos pixel location
  ra = (max(ra)-ra)*15*cos(dec*!pi/180.)*3600./appix/scl
  dec = (max(dec)-dec)*3600./appix/scl

 ;figure out dimensions needed at 1-for-1 scaling
  newx = round(max(ra)+sxpar(hdr,'NAXIS1')/scl)
  newy = round(max(dec)+sxpar(hdr,'NAXIS2')/scl)

  if keyword_set(sortem) then begin
   disp = sqrt(ra^2+dec^2)
   srt = sort(disp)
  endif else srt = indgen(nf)

  for i = 0,nf-1 do begin
   fits_datmask,infiles[srt[i]],im,hdr,mask
   if keyword_set(moremask) then mask=merge_mask(temporary(mask),moremask)

   med = median(im)
   ;im[mask] = med
   im[mask] = -10000

   if i eq 0 then begin
    szim = size(im)
    xs = fix(szim[1]/scl) & ys = fix(szim[2]/scl)
    window,0,xs=newx,ys=newy+10
    movie = bytarr(newx,newy+10,nf,/nozero)
   endif 
   
   erase
   tv,bytscl(congrid(im,xs,ys)/med,min=.95,max=1.1),fix(ra[srt[i]]),fix(dec[srt[i]])
   xyouts,fix(newx/2),newy,strmid(infiles[srt[i]],rstrpos(infiles[srt[i]],sls)+1,$
      strlen(infiles[srt[i]])-rstrpos(infiles[srt[i]],sls)-1),align=.5,/dev
 
   movie[*,*,i] = tvrd()

  endfor
  return,movie
 endif else begin
  print,'Cancelling...'
  return,-1
 endelse

end
