
function starflat_comp

 tfile = dialog_pickfile(title='Select text file')
 indir = dialog_pickfile(/dir,title='Select directory with FITS files')

 if tfile eq ''  or indir eq '' then retall

 openr,one,tfile,/get
 temp = ''
 while not eof(one) do begin
  readf,one,temp
  if strmid(temp,0,1) ne '#' then begin
   temp2 = strsplit(temp,'	',/extract)
   nn = n_elements(num)
   nt = n_elements(temp2)
   if nn eq 0 then begin
    mag = float(temp2[0])
    num = fix(temp2[1])
    xy = float(temp2[2:3])
    fwhm = float(temp2[nt-1])
   endif else begin
    tmag = mag & tnum = num & txy = xy & tfwhm = fwhm
    mag = fltarr(nn+1)
    mag[0] = tmag
    mag[nn] = float(temp2[0])
    num = intarr(nn+1)
    num[0] = tnum
    num[nn] = fix(temp2[1])
    xy = fltarr(2,nn+1)
    xy[0,0] = txy
    xy[*,nn] = float(temp2[2:3])
    fwhm = fltarr(nn+1)
    fwhm[0] = tfwhm
    fwhm[nn] = float(temp2[nt-1])
   endelse
  endif
 endwhile

 srt = sort(num)
 mag = mag[srt] & num = num[srt] & xy = xy[*,srt] & fwhm = fwhm[srt]

 i = 0
 while i lt nn+1 do begin
  if num[i] lt 10 then begin
   fnm = 'starflat_h.000'+strtrim(num[i],2)+'.fits'
  endif else fnm = 'starflat_h.00'+strtrim(num[i],2)+'.fits'

  w = where(num eq num[i],nw)
  print,indir+fnm
  fits_datmask,indir+fnm,im,hdr,mask
  sz = size(im)
  med = median(im)
  if (size(mask))[0] gt 1 then begin
   maskim = im*0+1
   mask = where(mask lt .1)
  endif 
  nm = n_elements(mask)
  if nm gt 0 and mask[0] gt -1 then begin
   maskim[mask] = 0
   xmask = mask mod sz[1]
   ymask = mask / sz[1]
   x1 = (xmask - 1) > 0
   x2 = (xmask + 1) < sz[1]-1
   y1 = (ymask - 1) > 0
   y2 = (ymask + 1) < sz[2]-1
   for j = 0l,nm-1l do begin
    good = where(maskim[x1[j]:x2[j],y1[j]:y2[j]] eq 1,ngood)
    if ngood gt 0 then im[mask[j]] = mean((im[x1[j]:x2[j],y1[j]:y2[j]])[good]) else im[mask[j]] = med
   endfor
  endif

  aper,im,xy[0,w],xy[1,w],flux,ferr,sky,skyerr,1,[5,10,15],[15,20],[0,0],/exact,/flux

  if i eq 0 then begin
   result = fltarr(11,nw)
   result[0,*] = num[w]
   result[1:2,*] = xy[*,w]
   result[3,*] = mag[w]
   result[4:6,*] = flux
   result[7,*] = flux[0,*]*10^(.4*mag[w])
   result[8,*] = flux[1,*]*10^(.4*mag[w])
   result[9,*] = flux[2,*]*10^(.4*mag[w])
   result[10,*] = fwhm[w]
  endif else begin
   tres = result
   result = fltarr(11,i+nw)
   result[0,0] = tres
   result[0,i:i+nw-1] = num[w]
   result[1:2,i:i+nw-1] = xy[*,w]
   result[3,i:i+nw-1] = mag[w]
   result[4:6,i:i+nw-1] = flux
   result[7,i:i+nw-1] = flux[0,*]*10^(.4*mag[w])
   result[8,i:i+nw-1] = flux[1,*]*10^(.4*mag[w])
   result[9,i:i+nw-1] = flux[2,*]*10^(.4*mag[w])
   result[10,i:i+nw-1] = fwhm[w]
  endelse

  i = i + nw
 endwhile

 return,result

end
  
