
function pv_get_stats,image_ptr,autoscale=autoscale,maskval=maskval

 if not keyword_set(maskval) then maskval = 0

 w = where(*image_ptr ne maskval,ct)

 if ct gt 0 then begin
  mo = moment((*image_ptr)[w],sdev=sd)
  med = median((*image_ptr)[w])
  minmax = [min((*image_ptr)[w]),max((*image_ptr)[w])]
 endif else begin
  mo = maskval
  sd = 0
  med = maskval
  minmax = replicate(maskval,2)
 endelse

 autoscale = [med - .5 * sd, med + 2 * sd]

 return,[mo[0],med,sd,minmax]

end


