
;*****************************************
;pv_phot_config cleanup routine
;*****************************************

pro pv_phot_config_kill,tlb_id

 widget_control,tlb_id,get_uvalue=ids
 widget_control,(*ids)[10],get_uvalue=state

 (*state).acfg_id = 0l

 ptr_free,ids

 widget_control,tlb_id,/destroy

end

;*****************************************
;pv_phot_config event handler
;*****************************************

pro pv_phot_config_event,event

 widget_control,event.top,get_uvalue=ids
 widget_control,(*ids)[10],get_uvalue=state
 widget_control,/hourglass

 switch event.id of

  (*ids)[1]: begin  ;aper field is changed
   minval = 1
   maxval = (*state).aper_defaults[1]
   field = 0
  end

  (*ids)[2]: begin  ;inner sky field has changed
;looks redundant, but this is switch, not case!!
;saves a lot of redundant code in the long run...
   if event.id eq (*ids)[2] then begin
    minval = (*state).aper_defaults[0]
    maxval = (*state).aper_defaults[2]-1
    field = 1
   endif
  end

  (*ids)[3]: begin  ;outer sky field has changed
   if event.id eq (*ids)[3] then begin
    minval = (*state).aper_defaults[1]+1
    maxval = 73.
    field = 2
   endif

;now for some action...
   widget_control,event.id,get_value=temp
   newtemp = temp > minval < maxval
   if newtemp ne temp then widget_control,event.id,set_value=newtemp
   obj = (*state).active_obj
   w = where((*(*state).aper_dat)[field,*] eq (*state).aper_defaults[field],wct)
   (*state).aper_defaults[field] = newtemp
   if wct gt 0 then (*(*state).aper_dat)[field,w] = newtemp
  end

  (*ids)[4]:begin   ;Photons per ADU field
   if event.id eq (*ids)[4] then begin
    widget_control,event.id,get_value=temp
    (*state).aper_defaults[3] = temp
    wct = n_elements(*(*state).find_status)
    w = lindgen(wct)
   endif
  end

  (*ids)[7]: begin  ;SET ALL APERS TO DEFAULTS button hit
   if event.id eq (*ids)[7] then begin
    wct = n_elements(*(*state).find_status)
    w = lindgen(wct)
    if wct gt 0 then $
       for i=0,2 do (*(*state).aper_dat)[i,w] = (*state).aper_defaults[i]
   endif

;now the rest of the action...
   if wct gt 0 then begin
    for i =0,wct-1 do begin
     aper,*(*state).main_dat[1],(*(*state).find_dat)[0,w[i]],$
          (*(*state).find_dat)[1,w[i]],mag,errap,sky,skyerr,(*state).aper_defaults[3], $
          (*(*state).aper_dat)[0,w[i]],(*(*state).aper_dat)[1:2,w[i]],[0,0],$
          /silent
     (*(*state).aper_dat)[3:6,w[i]] = [mag,errap,sky,skyerr]
    endfor
    (*(*state).aper_dat)[3,*] = (*(*state).aper_dat)[3,*]+((*state).aper_defaults[4]-25)
   endif
  end

  (*ids)[5]:begin   ;Magnitude Zero Point field
   if event.id eq (*ids)[5] then begin
    widget_control,event.id,get_value=temp
    (*(*state).aper_dat)[3,*] = (*(*state).aper_dat)[3,*]+(temp-(*state).aper_defaults[4])
    (*state).aper_defaults[4] = temp
   endif
   fevent = {top:(*ids)[10]}
   pv_photdisp,fevent
   break
  end

  (*ids)[6]: begin  ;DISMISS button hit
   widget_control,event.top,map=0
   return
  end

  else: break

 endswitch

 widget_control,hourglass=0

end

;*****************************************
;pv_phot_config initialization
;*****************************************

pro pv_phot_config,tlb_id

 widget_control,tlb_id,get_uvalue=state

 base = widget_base(title='PhotVis Config: Photometry Defaults', $
                    group_leader=tlb_id,/column,/base_align_center)

 (*state).acfg_id = base


 titles = ['Aperture Radius: ',$
           'Inner Sky Radius: ',$
           'Outer Sky Radius: ',$
           'Photons per ADU:',$
           'Magnitude Zero Point:',$
           'DISMISS',$
           'SET ALL APERS TO DEFAULTS']

 ids = ptr_new(lonarr(11,/nozero))

 (*ids)[10] = tlb_id

 subbase = widget_base(base,/column,/base_align_right)
 for i = 1,5 do begin
  (*ids)[i] = cw_field(subbase,/return_events,title=titles[i-1],$
                       /floating,value=((*state).aper_defaults)[i-1])
 endfor

 butbase = widget_base(base,/row,/base_align_center)

 for i = 6,7 do begin
  (*ids)[i] = widget_button(butbase,value=titles[i-1])
 endfor

 widget_control,base,set_uvalue=ids,/realize
 xmanager,'pv_phot_config',base,/no_block,cleanup='pv_phot_config_kill'

end

