;...............................................................
;
; 	integrate cube in l
;
;...............................................................

function int_slice_l,cube,l,l1=l1,l2=l2,order=order,clip=clip

  if NOT keyword_set(order) then order = "vxy"

  if keyword_set(clip) then begin
    data = cube * (cube gt clip)
  endif else begin
    data = cube
  endelse



  sum = 0
  diff = abs(l[1]-l[0])
  coord1 = 0
  coord2 = n_elements(l)-1

  for i = 0,n_elements(l)-1 do begin
    if (abs(l1-l[i]) le diff/2) then coord1 = i
    if (abs(l2-l[i]) le diff/2) then coord2 = i
  endfor
cube = cube * (cube gt .3)
  pixmin = coord1 < coord2
  pixmax = coord2 > coord1

;depending on order of x, y, and v, sum over all velocity channels
  case order of
    "vxy": sum = total(data[*,pixmin:pixmax,*],2)
    "xvy": sum = total(data[pixmin:pixmax,*,*],1)
    "xyv": sum = total(data[pixmin:pixmax,*,*],1)
  endcase
  
;convert units to T_a * db(degree)
  sum = sum*diff
  print,"max sum =",max(sum)

return,sum
end
