
pro make_irac_aor,obj,minpa,maxpa,overlap=overlap,contour_lev=contour_lev,version=version,fitsfile=fitsfile

 if not keyword_set(contour_lev) then conlev = 3 else conlev = contour_lev ; Av to contour
 if not keyword_set(overlap) then overlap = 13. ;min overlap requirement in arcsecs
 if not keyword_set(version) then version = '1' else version=strtrim(version,2)

 if keyword_set(fitsfile) then begin
  if file_test(fitsfile) then f = fitsfile else f=dialog_pickfile(title='Select Reference Av Map (FITS file)',/must_exist)
 endif else f=dialog_pickfile(title='Select Reference Av Map (FITS file)',/must_exist)

 if f eq '' then begin
  print,'Cancelled'
  retall
 endif

 fits_read,f,int2,hdr2

 extast,hdr2,astr
 naxis = sxpar(hdr2,'NAXIS*')
 gal = strmid(astr.ctype[0],0,1) eq 'G'
 if gal then begin
  xyad,hdr2,naxis[0]/2.,naxis[1]/2.,lc,bc
  euler,lc,bc,rc,dc,2

  x1=128.d0/1.2*sin([minpa,maxpa]*!pi/180)/cos(dc*!pi/180.)/3600.+rc
  y1=128.d0/1.2*cos([minpa,maxpa]*!pi/180.)/3600.+dc
  euler,x1,y1,l1,b1,1
  loff = (l1-lc)*cos(bc*!pi/180.)*3600.
  boff = (b1-bc)*3600.
; stop 
  for i=0,0 do begin
  if boff[i] ne 0 and loff[i] ne 0 then begin
   if abs(boff[i]) gt abs(loff[i]) then ba = 180./!pi*atan(abs(loff[i]/boff[i])) else ba = 90 - 180./!pi*atan(abs(boff[i]/loff[i]))
   case 1 of
    loff[i] gt 0 and boff[i] gt 0: npa=ba
    loff[i] gt 0 and boff[i] lt 0: npa=180-ba
    loff[i] lt 0 and boff[i] lt 0: npa=180+ba
    loff[i] lt 0 and boff[i] gt 0: npa=360-ba
   endcase
  endif else if boff[i] eq 0 then npa = 90+180.*(loff[i] ne abs(loff[i])) else if loff[i] eq 0 then npa = 180.*(boff[i] ne abs(boff[i]))
;  print,npa,npa-minpa,npa-maxpa,ba,loff,boff
  thoff = 0.+(npa-minpa)
  endfor
 endif else thoff = 0.
 delvarx,x1,y1
; xyad,hdr2,x1,y1,l,b

 posang = 0. ;don't rotate the grid, not supported

; Get the right offsets for the PA range specified.
 tstep=.1

 if minpa ge maxpa then maxpa2 = 360.+maxpa else maxpa2=maxpa
; if gal then thoff=90+(90-lat1) else thoff=90
 theta = dblarr(long((maxpa2-minpa)/tstep+1.9))*tstep+minpa-thoff
 x0 = theta
 y0 = theta
 xoff = overlap/1.2
 yoff = overlap/1.2
 for i=0,n_elements(x0)-1 do begin
  if (theta[i]+360) mod 90 gt 45 then theta2 = (90-((theta[i]+360) mod 90))*!pi/180. else theta2 = ((theta[i]+360) mod 90)*!pi/180.
;  x0[i] = ((128.-2*xoff)/cos(theta2))
  x0[i] = ((128.)/cos(theta2))
  theta2 = ((theta[i]+360) mod 90)*!pi/180.
;  if (theta[i]+360) mod 90 gt 45 then y0[i] = (-x0[i]*cos(theta2)/sin(theta2)+(256.-2*yoff)/sin(theta2))*2 else y0[i] = (-x0[i]*sin(theta2)/cos(theta2)+(256.-2*yoff)/cos(theta2))*2
  if (theta[i]+360) mod 90 gt 45 then y0[i] = (-x0[i]*cos(theta2)/sin(theta2)+(256.)/sin(theta2))*2 else y0[i] = (-x0[i]*sin(theta2)/cos(theta2)+(256.)/cos(theta2))*2
 endfor

 x0 = 2.*x0
 xstep = min(x0)*1.2-5*overlap
 ystep = min(y0)*1.2-2.5*overlap
 xstep2 = xstep
 ystep2 = ystep

 print,'For '+strtrim(minpa,2)+' < PA < '+strtrim(maxpa,2)+', I will use ['+strjoin(strtrim([xstep,ystep],2),', ')+'] arcsec RA/Dec steps.'

; if strmid(astr.ctype[0],0,1) eq 'G' then begin
;  print,"Sorry, have to convert image to RA-Dec."
;  heuler,astr,/celest
;  heuler,hdr2,/celest
;  naxis = sxpar(hdr2,'NAXIS*')
;  xyad,hdr2,[0,naxis[0]-1,naxis[0]-1,0],[0,0,naxis[1]-1,naxis[1]-1],ra,dec
;  getrot,astr,rang,cdelt
;  make_astr,astr2, DELT= cdelt, CRPIX = astr.crpix, CRVAL = astr.crval, CTYPE = ['RA---TAN','DEC--TAN'], pv2=[0.d0,0.d0], longpole=[180.d0],latpole=[90.d0]
;  ad2xy,ra,dec,astr2,x,y
;  astr2.crpix[0] -= min(x)
;  astr2.crpix[1] -= min(y)
;  hdr3 = hdr2
;  sxaddpar,hdr3,'NAXIS1',long(max(x)-min(x)+.5)
;  sxaddpar,hdr3,'NAXIS2',long(max(y)-min(y)+.5)
;  sxaddpar,hdr3,'EQUINOX',2000.
;  putast,hdr3,astr2
;  int0 = int2
;  hdr0 = hdr2
;  hastrom,int2,hdr2,int,hdr,hdr3,/interp,missing=0
;  int2 = temporary(int)
;  hdr2 = temporary(hdr)
; endif

 window,0,ys=800,xs=sxpar(hdr2,'NAXIS1')*.87/sxpar(hdr2,'NAXIS2')/.92*800
 a=" "
 pos = [.12,.07,.99,.99]

 w=where(1b-finite(int2),nw)
 if nw gt 0 then int2[w]=0

 robomean,int2,3,.3,avg,adev,sdev

 tvimage,bytscl(int2,min=avg-sdev,max=avg+5*sdev),/keep,/erase,pos=pos
 imcontour,int2,hdr2,levels=conlev,pos=pos,/noerase,/type,subtit=' ',c_color=256l^3-256l^2
; contour,int2,levels=conlev,pos=pos,/noerase,subtit=' ',c_color=256l^3-256l^2,/iso,/xsty,/ysty

;stop

 duh = dialog_message(/question,'Crop this image first?')
 if duh eq 'Yes' then duh = 'No' else duh = 'Yes'

 while duh ne 'Yes' do begin
  duh = dialog_message(/info,'Click the desired location of the lower left and upper right corners of your crop box')
  cursor,x1,y1,/data,4
  oplot,[x1],[y1],psym=2,color=255l,syms=3
;  duh = dialog_message(/info,'Click the upper right corner of your desired crop box')
  cursor,x2,y2,/data,4
  oplot,[x1,x2,x2,x1,x1],[y1,y1,y2,y2,y1],color=255l
  duh = dialog_message(/question,'Is this Crop satisfactory?')
  if duh ne 'Yes' then begin
   tvimage,bytscl(int2,min=avg-sdev,max=avg+5*sdev),/keep,/erase,pos=pos
   imcontour,int2,hdr2,levels=conlev,pos=pos,/noerase,/type,subtit=' ',c_color=256l^3-256l^2
  endif
 endwhile

 if n_elements(x1)+n_elements(x2) eq 2 then begin
  hextract,int2,hdr2,int,hdr,min([x1,x2]),max([x1,x2]),min([y1,y2]),max([y1,y2])
  window,0,ys=800,xs=sxpar(hdr,'NAXIS1')*.87/sxpar(hdr,'NAXIS2')/.92*800
  pos = [.12,.07,.99,.99]
  tvimage,bytscl(int,min=avg-sdev,max=avg+5*sdev),/keep,/erase,pos=pos
  imcontour,int,hdr,levels=conlev,pos=pos,/noerase,/type,subtit=' ',c_color=256l^3-256l^2

  duh = dialog_message(/question,'Save copy of Cropped image?')
  if duh eq 'Yes' then f2=dialog_pickfile(title='Save FITS file as') else f2=''
  if f2 ne '' then fits_write,f2,int,hdr else print,'Crop not saved'
 endif else begin
  int = temporary(int2) & hdr = temporary(hdr2)
 endelse

 ;fitsaxes,hdr,x,y,/cosy
 naxis = sxpar(hdr,'NAXIS*')
 getrot,hdr,rotang,cdelt

 xyad,hdr,lindgen(naxis[0]),lonarr(naxis[0]),x,crud
 xyad,hdr,lonarr(naxis[1]),lindgen(naxis[1]),crud,y

;check for x(ra) wraparound
 chk1 = (x-shift(x,-1))[0:n_elements(x)-2]
; chk2 = (x-shift(x,1))[1:n_elements(x)-1]
 w=where(abs(chk1) gt 350,nwrap) 
 if nwrap gt 0 then begin
  ww=where(x[[w,w+1]] eq max(x[[w,w+1]]),nww)
  xmnmx = [(w[0]+1)*(1-ww[0]),naxis[0]-1-(naxis[0]-1+w[0])*ww[0]]
  x[xmnmx[0]:xmnmx[1]] = x[xmnmx[0]:xmnmx[1]]+360
 endif

;in degrees?
 xrange=[max(x),min(x)]
 yrange=[min(y),max(y)]

 ra0 = mean(xrange) mod 360
 dec0 = mean(yrange)

 dx = long((xrange[0]-xrange[1])*3600.*cos(dec0*!pi/180.)/xstep+.99)
 dy = long((yrange[1]-yrange[0])*3600./ystep+.99)

;stop

; delvarx,pos&pos=[.05,.05,.99,.99]
;tvimage,tmp2,/keep,/erase,pos=pos
; tvimage,bytscl(int),/keep,/erase,pos=pos

; imcontour2,int,hdr,levels=conlev,pos=pos,/noerase,/type,xsty=5,ysty=5,xtickformat='(" ",a1)',ytickformat='(" ",a1)',xtit=' ',ytit=' ',subtit=' ',c_color=256l^3-256l^2

; plot,[0],[0],/noerase,pos=pos,xrange=xrange,yrange=yrange,xsty=5,ysty=5

; points1=clustergrid_tri2("tmp.tmp",ra0,dec0,dx+1,dx,dy+1,dy,xstep,ystep,posang)

 xstepp = xstep/abs(cdelt[0])/3600.
 ystepp = ystep/abs(cdelt[1])/3600.
 x0 = naxis[0]/2.
 y0 = naxis[1]/2.
 dx = long(naxis[0]/xstepp+.99)
 dy = long(naxis[1]/ystepp+.99)

 points1=clustergrid_tri2("tmp.tmp",x0,y0,dx+1,dx,dy+1,dy,xstepp,ystepp,posang)
 xstep = xstep2  & ystep=ystep2
 xy1 = points1
 xyad,hdr,xy1[0,*],xy1[1,*],rt,dt
; points1[0,*],points1[1,*],x,y
 points1[0,*] = rt
 points1[1,*] = dt
 oplot,xy1[0,*],xy1[1,*],color=256l^2-256l,psym=3;psym=2,syms=.2
 xrange = [0,naxis[0]-1]
 yrange = [0,naxis[1]-1]

;stop

 duh = 'Yes'
 npoly = 0
 poly_dat = ptrarr(50,/alloc)

; recover existing polygons?
 f3=file_search(obj+'_poly_*.dat',count=nf3)
 if nf3 gt 0 then begin
  for i=0,nf3-1 do begin
   tmp = strsplit(f3[i],'_',/extract)
   tmp = strmid(tmp[n_elements(tmp)-1],0,strpos(tmp[n_elements(tmp)-1],'.'))
   if i eq 0 then oldind=[tmp] else oldind = [oldind,tmp]
  endfor
  duh = dialog_message(/question,'Found '+strtrim(nf3,2)+' region polygon files ('+strjoin(oldind,',')+').  Use them?')
  if duh eq 'Yes' then begin
   for i=0,nf3-1 do begin
    poly1 = fmakepoly2(x,y,xrange=xrange,yrange=yrange,infile=f3[i],/plot,color=256l^3-256l^2+255,hdr=hdr)
    ;examine poly1 to make sure we're good for 2 degree crap
    wgd=where(poly1 ne -1000,ngd)
    if (max(poly1[0,*])-min(poly1[0,*]))*abs(cdelt[0]) ge 2 or (max(poly1[1,*])-min(poly1[1,*]))*abs(cdelt[1]) ge 2 or ngd eq 0 then rejected=1 else rejected=0
    if rejected then begin
     if ngd eq 0 then rtxt = 'polygon clicks not registering with program!' else rtxt = 'spans more than 2 degrees in RA or Dec'
     duh2 = dialog_message('Polygon #'+oldind[i]+' rejected: '+rtxt)
    endif else begin
     *poly_dat[fix(oldind[i])] = poly1
     if npoly eq 0 then goodind=[fix(oldind[i])] else goodind = [goodind,fix(oldind[i])]
     npoly = npoly+1
    endelse
   endfor
   duh = dialog_message(/question,'Need to define any more region polygons?')
  endif else duh = 'Yes'
 endif else duh = 'Yes'

 if npoly gt 0 then index = [goodind,indgen(50-npoly)+max(goodind+1)] else index = indgen(50)

; do new polygons
 while duh eq 'Yes' do begin
  duh = dialog_message(/info,'Click to mark perimeter of region polygon #'+strtrim(index[npoly],2)+'; when done, click on the window but outside the plot axes.')
  poly1 = fmakepoly2(x,y,xrange=xrange,yrange=yrange,infile="",/plot,color=256l^3-256l^2+255)
  wgd=where(poly1 ne -1000,ngd)
  poly2 = poly1 & xyad,hdr,poly1[0,*],poly1[1,*],rt,dt & poly2[0,*]=rt & poly2[1,*]=dt
  if (max(poly1[0,*])-min(poly1[0,*]))*abs(cdelt[0]) ge 2 or (max(poly1[1,*])-min(poly1[1,*]))*abs(cdelt[1]) ge 2 or ngd eq 0 then rejected=1 else rejected=0
  if rejected then begin
   if ngd eq 0 then rtxt = 'polygon clicks not registering with program!' else rtxt = 'spans more than 2 degrees in RA or Dec'     
   duh2 = dialog_message('Polygon rejected: '+rtxt)
   tvimage,bytscl(int,min=avg-sdev,max=avg+5*sdev),/keep,/erase,pos=pos
   imcontour,int,hdr,levels=conlev,pos=pos,/noerase,/type,subtit=' ',c_color=256l^3-256l^2
;   plot,[0],[0],/noerase,pos=pos,xrange=xrange,yrange=yrange,xsty=5,ysty=5
   oplot,xy1[0,*],xy1[1,*],color=256l^2-256l,psym=3;,psym=2,syms=.2
   for i=0,npoly-1 do oplot,(*poly_dat[index[i]])[0,*],(*poly_dat[index[i]])[1,*]
  endif else begin
   openw,1,obj+'_poly_'+strtrim(index[npoly],2)+'.dat'&printf,1,poly2&close,1
   *poly_dat[index[npoly]] = poly1
   npoly = npoly+1
  endelse
  if npoly eq 0 then duh='Yes' else duh = dialog_message(/question,'Would you like to add another region polygon?')
 endwhile

 if npoly eq 0 then begin
  print,'No polygons selected; Exiting.'
  retall
 endif

 tmp = poly_dat[npoly:49]
 ptr_free,tmp
 poly_dat = poly_dat[0:npoly-1]
 off_dat = ptrarr(npoly,/alloc) 
 off_dat2 = ptrarr(npoly,/alloc) 
 off_datg = ptrarr(npoly,/alloc) 
 off_datg2 = ptrarr(npoly,/alloc) 
 nskip = 0

 for i=0,npoly-1 do begin
  poly1 = *poly_dat[i]
  monr2_1x = finpoly(poly1,xy1)
  wgd = where(monr2_1x ne -1000,ngd)
  if ngd eq 0 then begin
   duh = dialog_message('Polygon #'+strtrim(index[i],2)+' contains no grid points!  Skipping!')
   if nskip eq 0 then skip = [i] else skip = [skip,i]
   nskip = n_elements(skip)
  endif else begin
; offset -4, +4 arcsecs for second epoch...  need keyword here?
   monr2_2x = monr2_1x & monr2_2x[0,*]=monr2_2x[0,*]+4./3600./abs(cdelt[0]) & monr2_2x[1,*]=monr2_2x[1,*]+4./3600./abs(cdelt[1])
   xyad,hdr,monr2_1x[0,*],monr2_1x[1,*],rt,dt
   monr2_1 = monr2_1x & monr2_1[0,*]=rt & monr2_1[1,*]=dt
   xyad,hdr,monr2_2x[0,*],monr2_2x[1,*],rt,dt
   monr2_2 = monr2_1x & monr2_2[0,*]=rt & monr2_2[1,*]=dt

 ;  cluster_plot,0,data=monr2_1x
   oplot,monr2_1x[0,*],monr2_1x[1,*],psym=2,syms=.2,color=256l^3-256l^2+255l
   *off_datg[i]= monr2_2x
   *off_datg2[i]= monr2_1x
   if gal then begin
    euler,monr2_1[0,*],monr2_1[1,*],ra,dec,2
    monr2_1[0,*] = ra
    monr2_1[1,*] = dec
    euler,monr2_2[0,*],monr2_2[1,*],ra,dec,2
    monr2_2[0,*] = ra
    monr2_2[1,*] = dec
   endif
   *off_dat[i]= monr2_2
   *off_dat2[i]= monr2_1
;.run ~/work/idlpro/aor_stuff/irac_aor/cluster
   if i eq 0 then begin
    noff = [long(n_elements(monr2_1)/2.)]
    alloff = [monr2_1]
   endif else begin
    noff = [noff,long(n_elements(monr2_1)/2.)]
    alloff = [[alloff],[monr2_1]]
   endelse
  endelse
 endfor

; noff = long([n_elements(monr2_1),n_elements(monr2_2),n_elements(monr2_3),n_elements(monr2_4),n_elements(monr2_5),n_elements(monr2_6),n_elements(monr2_7)]/2.)

; alloff = [[monr2_1],[monr2_2],[monr2_3],[monr2_4],[monr2_5],[monr2_6],[monr2_7]]

; bogus=lindgen(total(noff))
 nover = 0
 for i=0l,total(noff)-1 do begin
  diff1=abs(alloff[0,*]-alloff[0,i])
  diff2=abs(alloff[1,*]-alloff[1,i])
  w=where(diff1 lt 1./3600. and diff2 lt 1./3600.,nw)
  if nw eq 0 then print,'test not working'
  if nw gt 1 then begin
   if nover eq 0 then over = [w[where(w ne i)]] else over=[over,w[where(w ne i)]]
   nover = n_elements(over)
  endif
;print,strtrim(w[where(w ne i)],2)+' is repeated'
 endfor
 if nover gt 0 then duh = dialog_message("Polygon overlap detected; some grid points are repeated!  Easy solution: redo your polygons such that none cover the same grid points.  If this is a real pain to you, bribe Rob with promises of beer to write a code to filter these out automatically.")
; print,'done'

;.run clusteroffset_v9
 for i=0,npoly-1 do begin
  if nskip gt 0 then wbd = where(skip eq index[i],nbd) else nbd=0
  if nbd eq 0 then begin
   order = clusteroffset_v8b(*off_datg[i],outfile=obj+"_irac_v"+version+".aor",label="IRAC_"+obj+"_"+strtrim(index[i],2)+"_1",target_name=obj+'_irac'+strtrim(index[i],2),incx_step=xstep,incy_step=ystep,aor_ind=aor_ind,exist=(i gt 0))
;   stop
   monr2off = clusteroffset_v8(*off_dat[i],outfile=obj+"_irac_v"+version+".aor",label="IRAC_"+obj+"_"+strtrim(index[i],2)+"_1",target_name=obj+'_irac'+strtrim(index[i],2),incx_step=xstep,incy_step=ystep,aor_ind=aor_ind,exist=(i gt 0),index=order)
  endif
 endfor 
; for i=0,npoly-1 do monr2off = clusteroffset_v9(*off_dat[i],outfile=obj+"_irac_v1.aor",label=obj+"_epoch1",target_name=obj,incx_step=xstep,incy_step=ystep,aor_ind=aor_ind,posang=posang,/plot)
 delvarx,aor_ind
 for i=0,npoly-1 do begin
  if nskip gt 0 then wbd = where(skip eq index[i],nbd) else nbd=0
  if nbd eq 0 then begin
   order = clusteroffset_v8b(*off_datg2[i],outfile=obj+"_irac_v"+version+".aor",label="IRAC_"+obj+"_"+strtrim(index[i],2)+"_2",target_name=obj+'_irac'+strtrim(index[i],2),incx_step=xstep,incy_step=ystep,follow="IRAC_"+obj+"_"+strtrim(index[i],2)+"_1",aor_ind=aor_ind,/exist)
   monr2off = clusteroffset_v8(*off_dat2[i],outfile=obj+"_irac_v"+version+".aor",label="IRAC_"+obj+"_"+strtrim(index[i],2)+"_2",target_name=obj+'_irac'+strtrim(index[i],2),incx_step=xstep,incy_step=ystep,follow="IRAC_"+obj+"_"+strtrim(index[i],2)+"_1",aor_ind=aor_ind,/exist,index=order)
  endif
 endfor
 openw,1,obj+"_irac_v"+version+".aor",/append
 openr,2,'follow.tmp' & tmp=''&z=0
 while not eof(2) do begin&readf,2,tmp&printf,1,tmp&endwhile&close,1 &close,2&file_delete,'follow.tmp',/quiet
; tmp = strarr(z) & point_lun,2,0 & readf,2,tmp &printf,1,tmp&close,1 &close,2& file_delete,'follow.tmp',/quiet

delvarx,aor_ind
;imcontour2,int,hdr,levels=conlev,pos=pos,/noerase,/type,xsty=5,ysty=5,xtickformat='(" ",a1)',ytickformat='(" ",a1)',xtit=' ',ytit=' ',subtit=' ',c_color=256l^3-256l^2

ptr_free,poly_dat,off_dat,off_dat2,off_datg,off_datg2
print,'AOR file '+obj+"_irac_v"+version+".aor is written...  DONE!!"

end

