;-----------------------------------------------------
;
;	testcoverage
;
;	This program produces a map of the pixel coverage given
;	the inputs for a rectangular grid.
;
;	S. T. Megeath (3-00)
;
;-----------------------------------------------------

function testcoverage,arrsize,mossize,n,m,deltan,deltam,rotang,$
    celestial=celestial,crot=crot,xoff=xoff,yoff=yoff,$
    cxoff=cxoff,cyoff=cyoff,mos1=mos1

    if NOT keyword_set(xoff) then xoff=0.
    if NOT keyword_set(cxoff) then cxoff=0.
    if NOT keyword_set(yoff) then yoff=0.
    if NOT keyword_set(cyoff) then cyoff=0.

    if NOT keyword_set(mos1) then mos1 = replicate(0.,mossize,mossize)

    rotang = -rotang
    arrsize = fix(arrsize/2+.5)*2

    image = replicate(0,mossize,mossize)
    image[mossize/2-arrsize/2+1:mossize/2+arrsize/2,$
          mossize/2-arrsize/2+1:mossize/2+arrsize/2] = 1
    newim = rot(image,rotang)


    if keyword_set(celestial) then  rotang = 0
    if keyword_set(crot) then rotang = -crot
    rotang = rotang*2*3.141592654/360.

    for i = 0,n-1 do begin
      for j = 0,m-1 do begin
         transx = (i*deltan-n/2.*deltan+xoff)*cos(rotang)$
                 +(j*deltam-m/2.*deltam+yoff)*sin(rotang)+cxoff
         transy = (j*deltam-m/2.*deltam+yoff)*cos(rotang)$
                 -(i*deltan-n/2.*deltan+xoff)*sin(rotang)+cyoff
         x = findgen(mossize)-transx
         y = findgen(mossize)-transy
          mos1 = mos1+interpolate(newim,x,y,/grid,missing=0)
       endfor
     endfor
     tv,bytscl(rebin(mos1,mossize,mossize,/sample),min=0,max=4)

    return,mos1
end         
