
pro align1,app

 out_2mass = parse_2mass4()
 fname1 = dialog_pickfile(/must_exist,title='Select PVDAT file')

 if fname1 ne '' then restore,fname1
 npv = n_elements(pv_dat[0,*])
 if npv eq 0 then begin
  print,'Cancelled, or file invalid'
  retall
 endif

 rdcent = [double(median(out_2mass[0,*])),double(median(out_2mass[1,*]))]
 xy_2mass = out_2mass[0:1,*]
 xy_2mass[0,*] = (rdcent[0] - out_2mass[0,*])*3600./app*cos(out_2mass[1,*]*!pi/180.)
 xy_2mass[1,*] = (out_2mass[1,*] - rdcent[0])*3600./app

;assume 2mass data is centered
 imcent = [max(pv_dat[0,*]),max(pv_dat[1,*])]/2.
 w = where(xy_2mass[0,*] lt imcent[0] and xy_2mass[0,*] gt -1*imcent[0] and $
           xy_2mass[1,*] lt imcent[1] and xy_2mass[1,*] gt -1*imcent[1],n2m)

 xdis = fltarr(n2m*npv) & ydis = xdis

 for j = 0l,n2m-1 do begin
  for i = 0l,npv-1 do begin
   xdis[j*npv+i] = xy[0,w[j]] - pv_dat[0,i]
   ydis[j*npv+i] = xy[1,w[j]] - pv_dat[1,i]
  endfor
 endfor

 window,0&plot,histogram(xdis,bin=2),psym=10


