
function bima_core,rad=rad

 if strlowcase(!version.os_family) eq 'windows' then sls = '\' else sls = '/'

 if not keyword_set(rad) then rad = 3. / .204

 dir = dialog_pickfile(/dir,title='Select directory with coaligned BIMA data')

 if dir eq '' then retall

 hnm = findfile(dir+'*f160?.fits',count=nh)
 window,0,xs=500,ys=500
 out = fltarr(7,nh)

 for i=0,nh-1 do begin 
  print,'Reading '+hnm[i]
  fits_read,hnm[i],im,hdr

  med = median(im)
  mo = moment(im,sdev=sd)
  tv,bytscl(im,min=med-1*sd,max=med+2*sd)

  huh = dialog_message(/ques,'Is there an obvious core?')
  flag = 0

  while huh eq 'Yes' do begin
   flag = 1
   tv,bytscl(im,min=med-1*sd,max=med+2*sd)
   print,'Click center of core...'
   cursor,x,y,/dev 
   tvcircle,rad,x,y
   huh = dialog_message('Redo this selection?',/ques)
  endwhile

  if flag then begin
   np = rstrpos(hnm[i],'n')
   fp = strpos(strmid(hnm[i],np+1,5),'f')
   num = strmid(hnm[i],np+1,fp)
   if strlen(num) eq 3 then num = '0' + num

   bnm = findfile(dir+'NGC'+num+'*',count=nb)
   if nb eq 0 then stop
   fits_read,bnm[0],bim,bhdr
   wn = where(1-finite(bim),nn)
   if nn gt 0 then bim[wn] = 0
   fits_read,dir+'n'+strtrim(fix(num),2)+'pa.fits',pim,phdr

   aper,bim,x,y,flux,ferr,sky,serr,1,rad,[rad+5,rad+10],[0,0],/flux,/exact,$
      setskyval=0 
   bflux = flux*92./sxpar(bhdr,'bmaj')/sxpar(bhdr,'bmin')/3600.^2*4.45*$
      (sxpar(phdr,'dist_mpc')*4.85)^2

   pflux = fltarr(5)

   for j=0,4 do begin
    if j gt 0 then begin
     psmth = median(oldpim,5*(5-j))
     pim = oldpim - psmth
    endif else oldpim = pim
    aper,pim,x,y,flux,ferr,sky,serr,1,rad,[rad+5,rad+10],[0,0],/flux,/exact
    pflux[j] = flux*10^(.4*sxpar(phdr,'gal_extn'))*sxpar(phdr,'photflam')*$
       8.46*191.*4.*!pi*(sxpar(phdr,'dist_mpc') * 3.085d24)^2 / 1.25d41
   endfor
   
   out[*,i] = [float(num),bflux,pflux] 
  endif else out[0,i] = -1
  
 endfor

 w = where(out[0,*] ne -1,nw)
 if nw gt 0 then out = out[*,w]
 return,out
 
end

