
pro fake_cluster,king=king,wcs=wcs,refpvd=refpvd,pix2pc=pix2pc,halfwidth=halfwidth,bkdense=bkdense,maglimit=maglimit,refcent=refcent,dist=dist

 if not keyword_set(dist) then dist = 700.
 pos = [.1,.1,.98,.98]
 window,0,xs=700,ys=700
 if not keyword_set(wcs) then wcs = $
    {pix_center:[1638l,1464l],RADEC_CENTER:[301.78113d0,27.486309d0],$
    cd:reform([-4.63889e-05,0.00000,0.00000,4.63889e-05],2,2)}
 if not keyword_set(pix2pc) then pix2pc = .167*700./2.e5
 gsz = [3300l,3300l,3300l]
 if not keyword_set(halfwidth) then halfwidth=.08
 chw = halfwidth
 
 if not keyword_set(bkdense) then bkdense = 275.   ;#/pc^-2

;gaussian model
; inrad = findgen(1001)/1000.*pix2pc*sqrt(gsz[0]^2+gsz[1]^2+gsz[2]^2)
; gmod = exp(-1.*inrad^2./(2.*chw/2.35482)^2)
 
;king model
 if not keyword_set(king) then king = [3200.,.035,.25]
 inrad = findgen(101)/100.*king[2]
 kmod = king[0]*((1.+(inrad/king[1])^2.)^(-.5) - (1.+(king[2]/king[1])^2.)^(-.5))
 oldkmod = kmod
;2D for now
 kmodn = kmod*2.*!pi*inrad*king[2]/100.
 nclstars = long((randomu(seed,1,poisson=total(kmodn)))[0]+.5)

;3d attempt
 zconv = 2.*(king[2]^2.-inrad^2.)^.5
; kmodz = [(reverse(kmod*zconv))[0:99],kmod*zconv]
 kmodz = [(reverse(kmod))[0:99],kmod]
 kmodn = kmodn*zconv
; nclstars = total(kmod)
 kmodprob = total(kmodn,/cumulative)/total(kmodn)
 kmodprob2 = total(kmodz,/cumulative)/total(kmodz)
; nclstars = 100
 print,'Cluster Stars: '+strtrim(nclstars,2)

 nbkstars = long((randomu(seed,1,poisson=bkdense*(pix2pc)^2*gsz[0]*gsz[1]))[0]+.5)
 print,'Background Stars: '+strtrim(nbkstars,2)

;make "background" stars...  ie, fill cube uniformly

 bkdat = [transpose(randomu(seed,nbkstars,/uniform))*gsz[0],$
          transpose(randomu(seed,nbkstars,/uniform))*gsz[1],$
          transpose(randomu(seed,nbkstars,/uniform))*gsz[2]]

;make cluster, gaussian distribution at center of cube via monte carlo
; r = 2.*chw/2.35482 * sqrt(-1.*alog(randomu(seed,nclstars,/uniform)))

;king model
 rnd = randomu(seed,nclstars,/uniform)
 rnd2 = randomu(seed,nclstars,/uniform)
 r = rnd
 z = rnd2
 for i = 0,nclstars-1 do begin
  w = where(kmodprob gt rnd[i])
  w2 = where(kmodprob2 gt rnd2[i])
  r[i] = (rnd[i]-kmodprob[w[0]-1])*inrad[w[0]-1]+(kmodprob[w[0]]-rnd[i])*inrad[w[0]]
  r[i] = r[i] / (kmodprob[w[0]]-kmodprob[w[0]-1]) / pix2pc
  zconv = (king[2]^2.-(r[i]*pix2pc)^2.)^.5 / pix2pc
  inz = [-1.*(reverse(inrad))[0:99],inrad] / king[2] * zconv
  z[i] = (rnd2[i]-kmodprob2[w2[0]-1])*inz[w2[0]-1]+(kmodprob2[w2[0]]-rnd2[i])*inz[w2[0]]
  z[i] = z[i] / (kmodprob2[w2[0]]-kmodprob2[w2[0]-1])
 endfor
 p = 2.*!pi*randomu(seed,nclstars,/uniform)
; t = !pi*randomu(seed,nclstars,/uniform)
 cldat = [transpose(r*cos(p))+gsz[0]/2.,$
          transpose(r*sin(p))+gsz[1]/2.,$
          transpose(z)+gsz[2]/2.]
; cldat = [transpose(r*sin(t)*cos(p))+gsz[0]/2.,$
;          transpose(r*sin(t)*sin(p))+gsz[1]/2.,$
;          transpose(r*cos(t))+gsz[2]/2.]

 plot,bkdat[0,*],bkdat[1,*],psym=2,syms=.3,xran=[0,3300],yran=[0,3300],/xstyle,/ystyle,pos=pos
 oplot,cldat[0,*],cldat[1,*],psym=2,syms=.3

 xypv_dat=fltarr(12,nclstars+nbkstars)
 xypv_dat[0:1,0:nclstars-1] = cldat[0:1,*]
 xypv_dat[0:1,nclstars:nclstars+nbkstars-1] = bkdat[0:1,*]

 out=gather_pv3(xypv_dat,gsz[0],gsz[1],18,dist=dist,numstars=5,wcs=wcs)
 contour,out,findgen(gsz[0]/18.)*18.,findgen(gsz[1]/18.)*18.,/noerase,pos=pos,$
         /xstyle,/ystyle,xran=[0,gsz[0]],yran=[0,gsz[1]],$
         levels=550.*2.^(findgen(5)+1),c_color=255l,c_thick=2
 window,2,xs=700,ys=700
 plot,bkdat[2,*],bkdat[1,*],psym=2,syms=.3,xran=[0,3300],yran=[0,3300],/xstyle,/ystyle,pos=pos
 oplot,cldat[2,*],cldat[1,*],psym=2,syms=.3

 yzpv_dat=fltarr(12,nclstars+nbkstars)
 yzpv_dat[0,0:nclstars-1] = cldat[2,*]
 yzpv_dat[1,0:nclstars-1] = cldat[1,*]
 yzpv_dat[0,nclstars:nclstars+nbkstars-1] = bkdat[2,*]
 yzpv_dat[1,nclstars:nclstars+nbkstars-1] = bkdat[1,*]

 out=gather_pv3(yzpv_dat,gsz[0],gsz[1],18,dist=dist,numstars=5,wcs=wcs)
 contour,out,findgen(gsz[0]/18.)*18.,findgen(gsz[1]/18.)*18.,/noerase,pos=pos,$
         /xstyle,/ystyle,xran=[0,gsz[0]],yran=[0,gsz[1]],$
         levels=550.*2.^(findgen(5)+1),c_color=255l,c_thick=2

 window,1
 radial_plot1,infile=xypv_dat,center=gsz[0:1]/2.,pix2pc=pix2pc,bin_size=40
 radial_plot1,infile=refpvd,center=refcent,pix2pc=pix2pc,$
              bin_size=40,maglimit=maglimit,/overplot
 oplot,inrad,oldkmod+bkdense
 window,3
 radial_plot1,infile=yzpv_dat,center=gsz[1:2]/2.,pix2pc=pix2pc,bin_size=40
 radial_plot1,infile=refpvd,center=refcent,pix2pc=pix2pc,$
              bin_size=40,maglimit=maglimit,/overplot
 oplot,inrad,oldkmod+bkdense

end

