
pro flat_collate,sky=sky

 if strlowcase(!version.os_family) eq 'windows' then sls = '\' else sls = '/'

 on = dialog_pickfile(/mult,title='Select FITS files of bright sky flats')
 non = n_elements(on)
 if non eq 1 and on[0] eq '' then begin
  print,'ERROR in flat_collate: no files selected'
  retall
 endif

 if keyword_set(sky) then off = shift(on,-1) else begin
  off = dialog_pickfile(/mult,title='Select FITS files of dark sky flats')
 endelse

 noff = n_elements(off)
 if noff eq 1 and off[0] eq '' then begin
  print,'ERROR in flat_collate: no files selected'
  retall
 endif

 outdir = dialog_pickfile(/dir,title='Select directory for output FITS files')
 if outdir eq '' then begin
  print,'ERROR in flat_collate: no directory selected'
  retall
 endif

 if sls eq '/' then file_mkdir,outdir

 last = min([noff,non])
 
 for i = 0,last-1 do begin
  print,'Reading '+off[i]
  fits_datmask,off[i],imoff,offhdr,offmask
  print,'Reading '+on[i]
  fits_datmask,on[i],imon,onhdr,onmask

  if keyword_set(sky) then begin
   back = median(imoff) 
   sxaddpar,onhdr,'HISTORY','sky subtracted'
  endif else begin
   back = 0.
   sxaddpar,onhdr,'HISTORY','bright sky flat minus dark sky flat'
  endelse

  im = temporary(imon) - temporary(imoff) + back
  mask = merge_mask(temporary(onmask),temporary(offmask))

  temp = strsplit(on[i],sls,/extract)
  fname = temp[n_elements(temp)-1]
  out = outdir+fname

  print,'Writing '+out
  fits_datmask,/write,out,im,onhdr,mask
 endfor

end

