;----------------------------------------------------------------------------
;
;	imexam
;
;	This program examines an image using a radial plot, histogram,
;       and a display of pixel values.  The image must already be 
;       displayed.
;
;-----------------------------------------------------------------------------


pro imexam,image,x_mos,y_mos,size,centroid=centroid,centersize=centersize,$
    show=show,tvmin=tvmin,tvmax=tvmax

save_x = !x
save_y = !y
save_p = !p
oldpmulti = !p.multi
!p.multi = [0,2,3]
window,3,xs=600,ys=800,retain=2
save_x_3 = !x
save_y_3 = !y
save_p_3 = !p
wset,0
!p = save_p
!y = save_y
!x = save_x


cursor,xcoord,ycoord,/dev
while (!MOUSE.button NE 4) do begin

;  print,xcoord,ycoord
  xpix = n_elements(x_mos)
  ypix = n_elements(y_mos)
  pixx = round((xcoord-x_mos[0])/(x_mos[1]-x_mos[0]))
  pixy = round((ycoord-y_mos[0])/(y_mos[1]-y_mos[0]))

; check to see if pixels is in bound00s
;  print,xcoord,ycoord,x_mos[pixx],y_mos[pixy],pixx,pixy,xpix,ypix
  print,xcoord,ycoord,pixx,pixy,xpix,ypix
  if (pixx ge 0) AND (pixx le xpix) AND (pixy ge 0) $
      AND (pixy le ypix) then begin

; try centroiding
  if keyword_set(centroid) then begin
    new = center(image,pixx,pixy,10,size,-10,500000,5,tvmin=tvmin,tvmax=tvmax)
    pixx = round(new.xc)
    pixy = round(new.yc)
  endif

;plot square
  if keyword_set(show) then begin
    oplot,[x_mos[pixx-size],x_mos[pixx+size],x_mos[pixx+size],$
           x_mos[pixx-size],x_mos[pixx-size]],$
          [y_mos[pixy-size],y_mos[pixy-size],y_mos[pixy+size],$
           y_mos[pixy+size],y_mos[pixy-size]]
  endif

    wset,3
    !p = save_p_3
    !y = save_y_3
    !x = save_x_3
  endif else begin
    return
  endelse

  plot,image[pixx,pixy-size:pixy+size],psym=10,charsize=2
  plot,image[pixx-size:pixx+size,pixy],psym=10,charsize=2
  hist = histogram(image[pixx-size:pixx+size,pixy-size:pixy+size])
  minim = min(image[pixx-size:pixx+size,pixy-size:pixy+size])
  x = findgen(n_elements(hist))+minim+0.5
  plot,x,hist,psym=10,charsize=2
  contour,image[pixx-size:pixx+size,pixy-size:pixy+size],charsize=2
  surface,image[pixx-size:pixx+size,pixy-size:pixy+size],charsize=2
  rad = fltarr(2*size+1,2*size+1)
  for i = -size, size do begin
    for j = -size, size do begin
       rad[i+size,j+size] = sqrt(i*i+j*j)
    endfor
  endfor
;  print,rad
  plot,reform(rad),reform(image[pixx-size:pixx+size,pixy-size:pixy+size]),$
       psym=3,charsize=2
  wset,0
  !p = save_p
  !y = save_y
  !x = save_x

cursor,xcoord,ycoord,/dev
endwhile

!p.multi=oldpmulti

return
end
