
pro tc_diagnose1

;get filenames
 f1 = dialog_pickfile(title='Select Red band FITS file',/must)
 f2 = dialog_pickfile(title='Select Green band FITS file',/must)
 f3 = dialog_pickfile(title='Select Blue band FITS file',/must)

;read in those images with headers
 fits_read,f1,im1,hdr1
 fits_read,f2,im2,hdr2
 fits_read,f3,im3,hdr3

;get array sizes
 sz1 = size(im1)
 sz2 = size(im2)
 sz3 = size(im3)

;check for NaN, Infinity, etc.
 w = where(finite(im1) eq 0,nbd1)
 w = where(finite(im2) eq 0,nbd2)
 w = where(finite(im3) eq 0,nbd3)

;get mean, median, stddev, min, and max, which the autoscaler uses
 mo1 = moment(im1,sdev=std1)
 mo2 = moment(im2,sdev=std2)
 mo3 = moment(im3,sdev=std3)
 med1 = median(im1)
 med2 = median(im2)
 med3 = median(im3)
 min1 = min(im1)
 min2 = min(im2)
 min3 = min(im3)
 max1 = max(im1)
 max2 = max(im2)
 max3 = max(im3)
 
outname = dialog_pickfile(title='Save result as...')

save,hdr1,hdr2,hdr3,sz1,sz2,sz3,nbd1,nbd2,nbd3,mo1,mo2,mo3,$
     std1,std2,std3,med1,med2,med3,min1,min2,min3,max1,max2,max3,$
     file=outname

done = dialog_message(/info,'Please email '+outname+' to rguter@astro.pas.rochester.edu ...  Thanks!')
print,'Please email '+outname+' to rguter@astro.pas.rochester.edu ...  Thanks!'

end
