
function wcs_mosaic

 uno = dialog_pickfile(/must_exist,title='Master Image?')
 
 fits_datmask,uno,master,mhdr,tempmask
 if tempmask[0] eq -1 then begin
  mmask = finite(master)
  w=where(mmask eq 1,ngd)
  if ngd gt 0 then w2 = where(master[w] lt 0,nbd) else retall
  if nbd gt 0 then mmask[w[w2]] = 0
  tempmask = where(mmask eq 0)
 endif else begin 
  mmask = master*0.+1.
  mmask[tempmask]=0.
 endelse

 sxaddpar,mhdr,'CTYPE1',strmid(sxpar(mhdr,'CTYPE1'),0,8)
 sxaddpar,mhdr,'CTYPE2',strmid(sxpar(mhdr,'CTYPE2'),0,8)

; getrot,mhdr,rot1
 master[tempmask] = median(master)
; hrot,master,mhdr,master2,mhdr2,rot1,-1,-1,1,/pivot,missing=0
; hrot,mmask,mhdr,mmask2,mhdr2,rot1,-1,-1,1,/pivot,missing=0
; mmask2 = rot(mmask,rot1,/pivot,missing=0,/interp)
; master = temporary(master2)
; mmask = temporary(mmask2)
; mhdr = temporary(mhdr2)

 tmp = strsplit(uno,'/',/extract)
 fname = tmp[n_elements(tmp)-1]
 indir = '/'+strjoin(tmp[0:n_elements(tmp)-2],'/',/single)+'/'
 goodtime = sxpar(mhdr,'EXPTIME')

; f = findfile(indir+strmid(fname,0,2)+'*.fits')
 f = findfile(indir+strmid(fname,0,18)+'*.bcd_fp.fits')
 w = where(f ne uno)
 f = f[w]
 nf = n_elements(f)
 xmoff = 0. & ymoff = 0.
 
 gd = lonarr(nf)
 for i=0,nf-1 do begin
  fits_read,f[i],im,hdr,/header_only
  time = sxpar(hdr,'EXPTIME')
  gd[i] = time eq goodtime
 endfor

 f=f[where(gd eq 1)]&nf = n_elements(f)
 offsets = fltarr(2,nf)

 for i=0,nf-1 do begin
  fits_read,f[i],im,hdr,/header_only
  sxaddpar,hdr,'CTYPE1',strmid(sxpar(hdr,'CTYPE1'),0,8)
  sxaddpar,hdr,'CTYPE2',strmid(sxpar(hdr,'CTYPE2'),0,8)

  xyxy, hdr, mhdr, 0, 0, xoff, yoff
  offsets[*,i]=[xoff,yoff]
 endfor 

 for i=0,nf-1 do begin
  fits_datmask,f[i],im,hdr,tempmask 
;  hlp,tempmask
;  time = sxpar(hdr,'EXPTIME')

;  if time eq goodtime then begin
 if tempmask[0] eq -1 then begin
  mask = finite(im)
  w=where(mask eq 1,ngd)
  if ngd gt 0 then w2 = where(im[w] lt 0,nbd)
  if nbd gt 0 then mask[w[w2]] = 0
  tempmask = where(mask eq 0)
 endif else begin 
  mask = im*0.+1.
  mask[tempmask]=0.
 endelse

;   sxaddpar,hdr,'CTYPE1',strmid(sxpar(hdr,'CTYPE1'),0,8)
;   sxaddpar,hdr,'CTYPE2',strmid(sxpar(hdr,'CTYPE2'),0,8)

;   getrot,hdr,rot1 
   im[tempmask] = median(im)
;   hrot,im,hdr,im2,hdr2,rot1,-1,-1,1,/pivot,missing=0
;   hrot,mask,hdr,mask2,hdr2,rot1,-1,-1,1,/pivot,missing=0
;   im = temporary(im2)
;   mask = temporary(mask2)
;   hdr = temporary(hdr2)

   tvimage,bytscl(im,min=0,max=200),/keep
;   duh=dialog_message(/question,'Include?')
;   if duh eq 'Yes' then begin
;    xyxy, hdr, mhdr, 0, 0, xoff, yoff
 ;   print,xoff,yoff
;    xoff=float(xoff[0])
;    yoff=float(yoff[0])
    xoff=offsets[0,i]
    yoff=offsets[1,i] 

    mosaic_two,master,mmask,im,mask,xoff,yoff,xmoff,ymoff,/autoffset
    tvimage,bytscl(master,min=0,max=200),/keep
;    wait,1

    offsets[0,(i+1)<(nf-1):nf-1]=offsets[0,(i+1)<(nf-1):nf-1]+xmoff
    offsets[1,(i+1)<(nf-1):nf-1]=offsets[1,(i+1)<(nf-1):nf-1]+ymoff

;    oldx = sxpar(mhdr,'CRPIX1')
;    oldy = sxpar(mhdr,'CRPIX2')

;    sxaddpar,mhdr,'CRPIX1',oldx[0]+xmoff[0]
;    sxaddpar,mhdr,'CRPIX2',oldy[0]+ymoff[0]
;   endif
;  endif

 endfor
 
 out = {mosaic:master,master:mmask,hdr:mhdr} 

 return,out
end 
