
; converts X-Y pvdats to RA-Dec using WCS

pro wcs_pvd,pvdname=pvdname,fitsname=fitsname,outname=outname

 doh = 'x'
 while n_elements(doh) gt 0 do begin
  if not keyword_set(pvdname) then pvdname = dialog_pickfile(title='Select PV_DAT file',/must_exist)
  if pvdname eq '' then begin
   print,'Cancelled...'
   retall
  endif
  restore,pvdname
  if n_elements(pv_dat) eq 0 then begin
   doh=dialog_message(/error,'File selected ( '+pvdname+' ) is not a valid PV_DAT file!')
  endif else delvarx,doh
 endwhile

 if not keyword_set(fitsname) then fitsname = dialog_pickfile(title='Select FITS file with accurate WCS',/must_exist)
 if fitsname eq '' then begin
  print,'Cancelled...'
  retall
 endif
 if not keyword_set(outname) then outname = dialog_pickfile(title='Save WCS-based PV_DAT file as')
 if outname eq '' then begin
  print,'Cancelled...'
  retall
 endif

 pv_dat = double(pv_dat)
 fits_read,fitsname,im,hdr,/header_only

;In case I left the -SIP in the CTYPE keywords in the mosaics, which didn't 
;matter to the GSFC IDL lib until Feb 2004...  KILLING ME!!!
 sxaddpar,hdr,'CTYPE1',strmid(sxpar(hdr,'CTYPE1'),0,8)
 sxaddpar,hdr,'CTYPE2',strmid(sxpar(hdr,'CTYPE2'),0,8)

 xyad,hdr,reform(pv_dat[0,*]),reform(pv_dat[1,*]),ra,dec,/celest
 pv_dat[0,*] = ra
 pv_dat[1,*] = dec

 save,pv_dat,file=outname 

end
