
;*****************************************
;PV_Find_Config cleanup routine
;*****************************************

pro pv_find_config_kill,tlb_id

 widget_control,tlb_id,get_uvalue=ids

 widget_control,(*ids)[9],get_uvalue=state
 (*state).fcfg_id = 0l
 ptr_free,ids
 widget_control,tlb_id,/destroy

end

;*****************************************
;PV_Find_Config event handler
;*****************************************

pro pv_find_config_event,event

 widget_control,event.top,get_uvalue=ids

 widget_control,(*ids)[9],get_uvalue=state
 widget_control,/hourglass
 flg = 0       ;'fwhm has changed' flag
 case event.id of

  (*ids)[0]: begin                         ;on/off switch for autodetect
   widget_control,event.id,get_value=temp
   (*state).find_state[0] = temp[0]
   if (*state).find_state[1] then begin
    if (*state).find_state[0] then begin
     pv_find_init,state
     pv_dispcalc,state
    endif else begin
     widget_control,(*state).mode,set_value=0
     if (*state).curr_disp[0] eq (*state).conv_disp[0] then for i = 0,1 do $
        widget_control,(*state).scale[i],set_value=(*(*state).main_disp[1])[i]
     (*state).curr_dat = (*state).main_dat
     (*state).curr_disp = (*state).main_disp
     w = where(*(*state).find_status lt 0,fct)
     if fct gt 0 then begin
      *(*state).find_status = (*(*state).find_status)[w]
      *(*state).find_dat = (*(*state).find_dat)[*,w]
      *(*state).aper_dat = (*(*state).aper_dat)[*,w]
     endif else begin
      ptr_free,(*state).find_status,(*state).find_dat,(*state).aper_dat
      (*state).find_status = ptr_new(/alloc)
      (*state).find_dat = ptr_new(/alloc)
      (*state).aper_dat = ptr_new(/alloc)
     endelse
    endelse
    pv_sense,state
    pv_redisplay,(*ids)[9]
   endif
   return
  end

  (*ids)[1]: begin                  ;FWHM field is changed, need to reconvolve

;zero out convolved image so it can be remade
   *(*state).conv_dat[1] = -1
   widget_control,event.id,get_value=temp
   (*state).find_params[0] = temp
   flg = 2
  end

  (*ids)[2]: begin                                 ;hmin changed
   widget_control,event.id,get_value=temp
   (*state).find_params[1] = temp
   flg = 1
  end

  (*ids)[7]: begin                                ;DISMISS button hit
   widget_control,event.top,map=0
   return
  end

  (*ids)[8]: begin                           ;RESTORE DEFAULTS button hit
   (*state).find_params = (*state).find_defaults
   widget_control,(*ids)[1],get_value=fwhm
   widget_control,(*ids)[2],get_value=hmin

;check for change in fwhm or hmin
   if (*state).find_params[1] ne hmin then flg = 1
   if (*state).find_params[0] ne fwhm then begin
    *(*state).conv_dat[1] = -1
    flg = 2
   endif
   for i = 1,6 do widget_control,(*ids)[i],$
      set_value=(*state).find_params[i-1]
   widget_control,(*ids)[11],set_value=11.
   (*state).centerboxsize = 11.
  end

  (*ids)[10]: begin                          ;RESET USER ADDS button hit
   if (*state).n_objects[1] eq 0 then return
   if (*state).find_state[0] eq 0 then begin
    ptr_free,(*state).find_dat,(*state).find_status,(*state).aper_dat
    (*state).find_dat = ptr_new(/alloc)
    (*state).find_status = ptr_new(/alloc)
    (*state).aper_dat = ptr_new(/alloc)
    (*state).n_objects = [0l,0l]
    (*state).active_obj = -1
    widget_control,(*state).label[4],set_value=strtrim((*state).n_objects[0],2)
    pv_redisplay,(*ids)[9]
    widget_control,hourglass=0
    return
   endif

   *(*state).find_status = temporary(*(*state).find_status) > 0
   flg = 1
  end

  (*ids)[11]: begin                          ;centerboxsize changed
   widget_control,(*ids)[11],get_value=temp
   (*state).centerboxsize = temp[0] > 5
   if temp[0] lt (*state).centerboxsize then $
      widget_control,(*ids)[11],set_value=(*state).centerboxsize
   return
  end

  else: begin                      ;all other fields are search thresholds
   widget_control,event.id,get_value=temp
   w = where(*ids eq event.id)
   (*state).find_params[w[0]-1] = temp
  end
 endcase

;do something if autodetect is on
 if (*state).find_state[0] and (*state).find_state[1] then begin

;if fwhm was changed, have to rescale new convolved image
  if flg gt 0 then begin
   pv_find_detect,(*state).main_dat[1],(*state).find_params,$
                  (*state).conv_dat[1],(*state).find_dat,(*state).find_status,$
                  (*state).aper_dat
   w = where(*(*state).find_status ge 0,nob)
   if nob gt 0 then $
    for i = 0,2 do (*(*state).aper_dat)[i,w] = (*state).aper_defaults[i]
   (*state).n_objects[1] = n_elements(*(*state).find_status)

   for i = 0l,(*state).n_objects[1]-1 do begin
    aper,*(*state).main_dat[1],(*(*state).find_dat)[0,i],$
         (*(*state).find_dat)[1,i],mag,errap,sky,skyerr,(*state).aper_defaults[3], $
         (*(*state).aper_dat)[0,i],(*(*state).aper_dat)[1:2,i],[0,0],/silent,/exact
    (*(*state).aper_dat)[3:6,i] = [mag+((*state).aper_defaults[4]-25), errap, sky, skyerr]
   endfor
   (*state).active_obj = -1
   fevent = {top:(*state).tlb}
   pv_photdisp,fevent

   if flg gt 1 then begin
    *(*state).conv_dat[4] = pv_get_stats((*state).conv_dat[1],autoscale=minmax)

;s***can autoscale for convolved image
    minmax = [-.1,1] * (*state).find_params[1]

    *(*state).conv_dat[5] = bytscl(*(*state).conv_dat[1],min=minmax[0],$
       max=minmax[1])

    pv_dispcalc,state
    *(*state).conv_disp[1] = minmax

;if convolved is current display, have to reset scale fields
    if (*state).curr_disp[0] eq (*state).conv_disp[0] then for i = 0,1 do $
       widget_control,(*state).scale[i],set_value=minmax[i]
   endif
  endif

;run threshold search
  pv_find_search,(*state).find_dat,(*state).find_params,(*state).find_status

;count objects
  w = where(*(*state).find_status le 0,tmp)
  (*state).n_objects[0] = tmp

;update displays
  widget_control,(*state).label[4],set_value=strtrim((*state).n_objects[0],2)
  pv_redisplay,(*ids)[9]

 endif

 widget_control,hourglass=0

end

;*****************************************
;PV_Find_Config initialization
;*****************************************

pro pv_find_config,tlb_id

 widget_control,tlb_id,get_uvalue=state

 base = widget_base(title='PhotVis Config: Object Detection', $
                    group_leader=tlb_id,/column,/base_align_center)
 (*state).fcfg_id = base
 titles = ['FWHM: ',$
           'Intesity Threshold: ',$
           'Roundness Min: ',$
           'Roundness Max: ',$
           'Sharpness Min: ',$
           'Sharpness Max: ',$
           'DISMISS','RESTORE DEFAULTS',$
           'RESET USER ADDS','User Add Boxsize: ']
 ids = ptr_new(lonarr(12,/nozero))

 (*ids)[0] = cw_bgroup(base,['AutoDetect Active'],/nonexclusive,$
                       set_value=[(*state).find_state[0]],/frame,/return_name)

 (*ids)[9] = tlb_id
 subbase = widget_base(base,/column,/base_align_right,/frame)
 for i = 1,6 do begin
  (*ids)[i] = cw_field(subbase,/return_events,title=titles[i-1],$
                       /floating,value=(*state).find_params[i-1])
 endfor

 (*ids)[10] = widget_button(base,value=titles[8])
 subbase = widget_base(base,/column,/base_align_right)
 (*ids)[11] = cw_field(subbase,/return_events,title=titles[9],$
                       /floating,value=(*state).centerboxsize)
 butbase = widget_base(base,/row,/base_align_center)
 for i = 7,8 do begin
  (*ids)[i] = widget_button(butbase,value=titles[i-1])
 endfor
 widget_control,base,set_uvalue=ids,/realize
 xmanager,'pv_find_config',base,/no_block,cleanup='pv_find_config_kill'

end
