
;*****************************************
;pv_plot_config cleanup routine
;*****************************************

pro pv_plot_config_kill,tlb_id

 widget_control,tlb_id,get_uvalue=ids
 widget_control,(*ids)[10],get_uvalue=state

 (*state).pcfg_id = 0l

 ptr_free,ids

 widget_control,tlb_id,/destroy

end

;*****************************************
;pv_plot_config event handler
;*****************************************

pro pv_plot_config_event,event

 widget_control,event.top,get_uvalue=ids
 widget_control,(*ids)[10],get_uvalue=state

 case event.id of

;on/off switch for various plots
  (*ids)[0]: begin
   widget_control,event.id,get_value=temp
   (*state).plot_state = temp
  end

  (*ids)[1]: begin  ;psym field is changed
   widget_control,event.id,get_value=temp
   if temp lt 1 or temp gt 7 then begin
    temp = (*state).plot_params[0]
    widget_control,event.id,set_value=temp
   endif else (*state).plot_params[0] = temp
  end

  (*ids)[2]: begin  ;plot size field has changed
   widget_control,event.id,get_value=temp
   (*state).plot_params[1] = temp
  end

  (*ids)[3]: begin  ;imexam box size has changed
   widget_control,event.id,get_value=temp
   (*state).plot_params[2] = temp
  end 

  (*ids)[4]: begin  ;Disable all plots button hit
   (*state).plot_state = [0,0,0]
   widget_control,(*ids)[0],set_value=[0,0,0]
  end

  (*ids)[7]: begin  ; Enable all plots button hit
   (*state).plot_state = [1,1,1]
   widget_control,(*ids)[0],set_value=[1,1,1]
  end

  (*ids)[5]: begin  ;DISMISS button hit
   widget_control,event.top,map=0
   return
  end

  (*ids)[6]: begin  ;RESTORE DEFAULTS button hit
   (*state).plot_params = [6.,1.,8. * (*state).find_params[0]]
   for i = 1,3 do widget_control,(*ids)[i],$
      set_value=(*state).plot_params[i-1]
  end

  else: break

 endcase

 pv_redisplay,(*ids)[10]

 widget_control,hourglass=0

end

;*****************************************
;pv_plot_config initialization
;*****************************************

pro pv_plot_config,tlb_id

 widget_control,tlb_id,get_uvalue=state

 base = widget_base(title='PhotVis Config: Overplots', $
                    group_leader=tlb_id,/column,/base_align_center)

 (*state).pcfg_id = base


 titles = ['Plot Character (PSYM): ',$
           'Character Size (SYMSIZE): ',$
           'ImExam Box Size: ',$
           'Disable All Plots', $
           'DISMISS','RESTORE DEFAULTS','Enable All Plots']

 ids = ptr_new(lonarr(11,/nozero))

 (*ids)[0] = cw_bgroup(base,['Rejected Objects (Red)',$
                       'Included Objects (Green)', $
                       'User-Added Objects (Blue)'],/nonexclusive,$
                       set_value=(*state).plot_state,/frame,/return_name)

 butbase = widget_base(base,/row,/base_align_center)
 (*ids)[4] = widget_button(butbase,value=titles[3])
 (*ids)[7] = widget_button(butbase,value=titles[6])

 (*ids)[10] = tlb_id

 subbase = widget_base(base,/column,/base_align_right)
 for i = 1,3 do begin
  (*ids)[i] = cw_field(subbase,/return_events,title=titles[i-1],$
                       /floating,value=((*state).plot_params)[i-1])
 endfor

 butbase = widget_base(base,/row,/base_align_center)

 for i = 5,6 do begin
  (*ids)[i] = widget_button(butbase,value=titles[i-1])
 endfor

 widget_control,base,set_uvalue=ids,/realize
 xmanager,'pv_plot_config',base,/no_block,cleanup='pv_plot_config_kill'

end

