; 
;	xyv2vxy
;	
;	this program transposes xyv cubes to vxy cubes
;
;	parameters:	 infile  - input file
;			 outfile - output file
;
;	4-28-2003 S. T. Megeath
;
;------------------------------------------------------------------------------

pro xyv2vxy,infile,outfile

	fits_read,infile,data,header,/NaN

;	load in header variables

	outdata = transpose(data,[2,0,1])
	outheader = header

	ctype_ra = strmid(outheader[where(strmid(outheader,0,6) eq "CTYPE1")],10,20)
	crval_ra = strmid(outheader[where(strmid(outheader,0,6) eq "CRVAL1")],10,20)
	cdelt_ra = strmid(outheader[where(strmid(outheader,0,6) eq "CDELT1")],10,20)
	crpix_ra = strmid(outheader[where(strmid(outheader,0,6) eq "CRPIX1")],10,20)
	crota_ra = strmid(outheader[where(strmid(outheader,0,6) eq "CROTA1")],10,20)

	ctype_dec = strmid(outheader[where(strmid(outheader,0,6) eq "CTYPE2")],10,20)
	crval_dec = strmid(outheader[where(strmid(outheader,0,6) eq "CRVAL2")],10,20)
	cdelt_dec = strmid(outheader[where(strmid(outheader,0,6) eq "CDELT2")],10,20)
	crpix_dec = strmid(outheader[where(strmid(outheader,0,6) eq "CRPIX2")],10,20)
	crota_dec = strmid(outheader[where(strmid(outheader,0,6) eq "CROTA2")],10,20)

	ctype_vel = strmid(outheader[where(strmid(outheader,0,6) eq "CTYPE3")],10,20)
	crval_vel = strmid(outheader[where(strmid(outheader,0,6) eq "CRVAL3")],10,20)
	cdelt_vel = strmid(outheader[where(strmid(outheader,0,6) eq "CDELT3")],10,20)
	crpix_vel = strmid(outheader[where(strmid(outheader,0,6) eq "CRPIX3")],10,20)
	crota_vel = strmid(outheader[where(strmid(outheader,0,6) eq "CROTA3")],10,20)

	strput,"CTYPE1",ctype_vel,10	
	strput,"CRVAL1",crval_vel,10	
	strput,"CDELT1",cdelt_vel,10	
	strput,"CRPIX1",crpix_vel,10	
	strput,"CROTA1",crota_vel,10	

	strput,"CTYPE2",ctype_ra,10	
	strput,"CRVAL2",crval_ra,10	
	strput,"CDELT2",cdelt_ra,10	
	strput,"CRPIX2",crpix_ra,10	
	strput,"CROTA2",crota_ra,10	

	strput,"CTYPE3",ctype_dec,10	
	strput,"CRVAL3",crval_dec,10	
	strput,"CDELT3",cdelt_dec,10	
	strput,"CRPIX3",crpix_dec,10	
	strput,"CROTA3",crota_dec,10	


	fits_write,outfile,outdata,outheader

	return
end


