
; irac_dist - modify warping matrices to correct 2nd order distortion

pro irac_dist,im,hdr,mask,kx,ky,npix

; if n_elements(kx) eq 0 or n_elements(ky) eq 0 then begin
;  kx = fltarr(3,3)
;  ky = fltarr(3,3)
;  kx[0,1] = 1.
;  ky[1,0] = 1.
; endif

 if n_elements(npix) eq 0 then npix = 0

 a = [sxpar(hdr,'A_2_0'),sxpar(hdr,'A_1_1'),sxpar(hdr,'A_0_2')]
 b = [sxpar(hdr,'B_2_0'),sxpar(hdr,'B_1_1'),sxpar(hdr,'B_0_2')]
 crpix = [sxpar(hdr,'CRPIX1'),sxpar(hdr,'CRPIX2')] - 1

 sz = size(im)

 x0 = [0.,1.,2.,0.,1.,2.,0.,1.,2.]*(sz[1]-2*npix)/2.+npix
 y0 = [0.,0.,0.,1.,1.,1.,2.,2.,2.]*(sz[2]-2*npix)/2.+npix

 xdif = x0 - crpix[0]
 ydif = y0 - crpix[1]

 xdif1 = xdif+xdif^2.*a[0]+xdif*ydif*a[1]+ydif^2.*a[2]
 ydif1 = ydif+xdif^2.*b[0]+xdif*ydif*b[1]+ydif^2.*b[2]

 x1 = xdif1 + crpix[0]
 y1 = ydif1 + crpix[1]
 
; kx[0,0] = kx[0,0] + crpix[0]^2.*a[0]+crpix[0]*crpix[1]*a[1]+crpix[1]^2.*a[2]
; kx[0,1] = kx[0,1] - 2.*crpix[0]*a[0] - crpix[1]*a[1]
; kx[1,0] = kx[1,0] - 2.*crpix[1]*a[2] - crpix[0]*a[1]

; kx[1,1] = kx[1,1] + a[1]
; kx[0,2] = kx[0,2] + a[0]
; kx[2,0] = kx[2,0] + a[2]
;
; ky[0,0] = ky[0,0] + crpix[0]^2.*b[0]+crpix[0]*crpix[1]*b[1]+crpix[1]^2.*b[2]
; ky[0,1] = ky[0,1] - 2.*crpix[0]*b[0] - crpix[1]*b[1]
; ky[1,0] = ky[1,0] - 2.*crpix[1]*b[2] - crpix[0]*b[1]

; ky[1,1] = ky[1,1] + b[1]
; ky[0,2] = ky[0,2] + b[0]
; ky[2,0] = ky[2,0] + b[2]

 polywarp,x0,y0,x1,y1,2,kx,ky

end
