
pro irac_hdr_mask

 indir = dialog_pickfile(/directory,title='InDir?')
 f1 = findfile(indir+'f1*.fits')
 nf = n_elements(f1)
 f2 = f1[where(lindgen(nf) mod 2 eq 0)]
 f1 = f1[where(lindgen(nf) mod 2 eq 1)]
 m1 = findfile(indir+'m1*.fits')
 nm = n_elements(m1)
 m2 = m1[where(lindgen(nm) mod 2 eq 0)]
 m1 = m1[where(lindgen(nm) mod 2 eq 1)]
 if nm-nf ne 0 then retall

 outdir = dialog_pickfile(/directory,title='OutDir?')
 file_mkdir,outdir

 for i=0,nf/2-1 do begin
  tmp = strsplit(f1[i],'/',/extract)
  fname = tmp[n_elements(tmp)-1]
  print,'Processing '+fname
  fits_read,f1[i],iml,hdrl
  fits_read,f2[i],ims,hdrs
  fits_read,m1[i],maskl
  fits_read,m2[i],masks

;  if fix(sxpar(hdr,'ACHANID')) eq 1 or fix(sxpar(hdr,'ACHANID')) eq 2 then begin
   im2 = fpulldown(f1[i],objclip=3)
   w = where(finite(im2) eq 0,bad)
   if bad eq 0 and im2[0] ne -1 then iml=temporary(im2)
   im2 = fpulldown(f2[i],objclip=3)
   w = where(finite(im2) eq 0,bad)
   if bad eq 0 and im2[0] ne -1 then ims=temporary(im2)
;  endif

  scl = float(sxpar(hdrl,'EXPTIME'))/float(sxpar(hdrs,'EXPTIME'))
  ims = scl*temporary(ims)
  medl = median(iml)
  meds = median(ims)
  ims = temporary(ims) - meds + medl

;  wl = where(maskl le 32)
  ws = where(maskl gt 32 and masks le 32)
  wbad = where(maskl gt 32 and masks gt 32)
;  maskla = maskl*0 & maskla[wl] = 1 & iml[wl] = medl
;  masksa = masks*0 & masksa[ws] = 1 & ims[ws] = medl

;  mosaic_two,iml,maskla,ims,masksa,0,0,xmoff,ymoff
;  iml = iml[xmoff:xmoff+255,ymoff:ymoff+255]
;  maskla = maskla[xmoff:xmoff+255,ymoff:ymoff+255]
  iml[ws] = ims[ws]
  iml[wbad] = medl

  maskla = iml*0+1 & maskla[wbad] = 0
  im2 = fltarr(396,396)+medl & mask2 = im2*0
  
  im2[70,70] = iml & mask2[70,70] = maskla
  getrot,hdrl,rot1
  im = rot(im2,rot1,/interp,missing=medl)
  mask = rot(mask2,rot1,/interp,missing=0)
  fits_datmask,/write,outdir+fname,im,hdrl,mask

 endfor

end
