
;for BCD data

pro irac_mask_fix2,channels=channels

 if not keyword_set(channels) then channels = indgen(4)+1

 nchn = n_elements(channels)

 indir = dialog_pickfile(/directory,title='InDir?')
 for i=0,nchn-1 do begin
  f = findfile(indir+'IRAC.'+strtrim(channels[i],2)+'*bcd_fp.fits')
  if i gt 0 then f1 = [f1,f] else f1 = f
 endfor
 nf = n_elements(f1)
; f2 = findfile(indir+'m*.fits')
; nm = n_elements(f2)
; if nm-nf ne 0 then retall

 outdir = dialog_pickfile(/directory,title='OutDir?')
 file_mkdir,outdir

 for i=0,nf-1 do begin
  tmp = strsplit(f1[i],'/',/extract)
  fname = tmp[n_elements(tmp)-1]
  print,'Processing '+fname
  fits_read,f1[i],im,hdr
;  fits_read,f2[i],mask,hdr2

  if fix(sxpar(hdr,'CHNLNUM')) eq 1 or fix(sxpar(hdr,'CHNLNUM')) eq 2 then begin
   w = where(finite(im) eq 0,bad1)
   im2 = fpulldown(f1[i],objclip=3,/nofowler)
   w = where(finite(im2) eq 0,bad2)
   if bad1-bad2 eq 0 and im2[0] ne -1 then im=im2
  endif

  if fix(sxpar(hdr,'CHNLNUM')) eq 3 then begin
   w = where(finite(im) eq 0,bad1)
   im2 = fpulldown(f1[i],objclip=7,/nofowler,hsig=3,lsig=40)
   w = where(finite(im2) eq 0,bad2)
   if bad1-bad2 eq 0 and im2[0] ne -1 then im=im2
  endif

  if fix(sxpar(hdr,'CHNLNUM')) eq 4 then begin
;   im2 = fpulldown(f1[i],objclip=3,/nofowler)
;   w = where(finite(im2) eq 0,bad)
;   if bad eq 0 and im2[0] ne -1 then begin
;    im = im2
;    fits_write,'imf_tmp.fits',im,hdr
;    tnm = 'imf_tmp.fits'
;   endif else tnm = f1[i]
;   im2 = fpulldown2(tnm,objclip=3,/nofowler)
   w = where(finite(im) eq 0,bad1)
   im2 = fpulldown2(f1[i],objclip=7,/nofowler,hsig=3,lsig=40)
   w = where(finite(im2) eq 0,bad2)
   if bad1-bad2 eq 0 and im2[0] ne -1 then im=im2 
  endif

  mask = finite(im)
  w=where(mask eq 1,ngd)

;add back in zody and ism, assuming they were subtracted
  zody = sxpar(hdr,'ZODY_EST') > 0
  ism = sxpar(hdr,'ISM_EST') > 0
  im[w] = im[w]+zody+ism

;convert back to DN
  exptime = sxpar(hdr,'EXPTIME')
  fluxconv = sxpar(hdr,'FLUXCONV')
  im[w] = im[w]/fluxconv*exptime

;  if ngd gt 0 then w2 = where(im[w] lt 0,nbd)
;  if nbd gt 0 then mask[w[w2]] = 0
  tempmask = where(mask eq 0 or im lt 0,nbd)
  
;  w = where(mask eq 0)
  med = median(im[w])
;  im[w] = med
;  if med le 1. then begin
;   im[w] = im[w]+1.-med
;   med = 1.
;  endif
  if nbd gt 0 then im[tempmask] = med

;  im2 = fltarr(396,396)+med & mask2 = im2*0
;  im2[70,70] = im & mask2[70,70] = mask
;  getrot,hdr,rot1
;  im = rot(im2,rot1,/interp,missing=med)
;  mask = rot(mask2,rot1,/interp,missing=0)
  fits_datmask,/write,outdir+fname,im,hdr,tempmask

 endfor

end
