;extracted from Rob's irac_mask_fix2 and revised
;to work with c2d's naming convention and mask
;convention (0=good pix, 1=bad pix).
;
;for SIRTF_I*_bcd.fits and SIRTF_I*_icd.fits data
;with SIRTF_I*_c2dmask.fits masks
;
;does not run fpulldown or fpulldown2 procedures
;since the expected input is from infoaor.
;
;	T. Huard  07-15-2004
;	Last Revised  07-15-2004   4:00PM


pro irac_mask_fix_c2d,channels=channels

 if not keyword_set(channels) then channels = indgen(4)+1

 nchn = n_elements(channels)

 indir = dialog_pickfile(/directory,title='InDir?')
 for i=0,nchn-1 do begin
  f = findfile(indir+'SPITZER_I'+strtrim(channels[i],2)+'_*cd.fits')
  if i gt 0 then f1 = [f1,f] else f1 = f
 endfor
 nf = n_elements(f1)
 f2 = findfile(indir+'SPITZER_I*_c2dmask.fits')
 nm = n_elements(f2)
 if nm-nf ne 0 then begin
 	print,"ERROR: irac_mask_fix_c2d: Each image should have a corresponding mask."
 	retall
 endif
 outdir = dialog_pickfile(/directory,title='OutDir?')
 file_mkdir,outdir

 for i=0,nf-1 do begin
  tmp = strsplit(f1[i],'/',/extract)
  fname = tmp[n_elements(tmp)-1]
  print,'Processing '+fname
  fits_read,f1[i],im,hdr
  fits_read,f2[i],mask,hdr2

  w=where(mask ne 1,ngd) ; allows for c2dmask=2 for muxbleed (good pix)

;add back in zody and ism, assuming they were subtracted
  zody = sxpar(hdr,'ZODY_EST') > 0
  ism = sxpar(hdr,'ISM_EST') > 0
  im[w] = im[w]+zody+ism

;convert back to DN
  exptime = sxpar(hdr,'EXPTIME')
  fluxconv = sxpar(hdr,'FLUXCONV')
  im[w] = im[w]/fluxconv*exptime
  tempmask = where(mask eq 1 or im lt 0,nbd)
  med = median(im[w])
  if nbd gt 0 then im[tempmask] = med
  fits_datmask,/write,outdir+fname,im,hdr,tempmask

 endfor

end
