
pro irac_sort_data,f,xoffsets,yoffsets,workdir,nmos,derotate=derotate,order=order

 nf = n_elements(f)
 uno = f[0]
 f = f[1:nf-1]
 nf = nf-1

 fits_read,uno,master,mhdr,/header_only

 irac_expand_hdr,mhdr,70.

 getrot,mhdr,rot1

 if keyword_set(derotate) then irac_rot_hdr,mhdr,rot1

 sxaddpar,mhdr,'CTYPE1',strmid(strtrim(sxpar(mhdr,'CTYPE1'),2),0,8)
 sxaddpar,mhdr,'CTYPE2',strmid(strtrim(sxpar(mhdr,'CTYPE2'),2),0,8)

 goodtime = sxpar(mhdr,'EXPTIME')

 xmoff = 0. & ymoff = 0.

;clean out other-exposure HDR pics from file list for now
 gd = lonarr(nf)
 for i=0,nf-1 do begin
  fits_read,f[i],im,hdr,/header_only
  time = sxpar(hdr,'EXPTIME')
  gd[i] = time eq goodtime
 endfor

 f=[uno,f[where(gd eq 1)]]&nf = n_elements(f)
 npm = nf/nmos
 fnew = strarr(nmos,npm)
 forder = lonarr(nmos,npm)&tmporder = lindgen(nf)
 xoffsets = fltarr(nmos,npm)
 yoffsets = fltarr(nmos,npm)

 offsets = fltarr(2,nf)
 crpix = sxpar(mhdr,'CRPIX*')-1

;get WCS-based offsets
 for i=1,nf-1 do begin
  fits_read,f[i],im,hdr,/header_only

  irac_expand_hdr,hdr,70.

  if keyword_set(derotate) then irac_rot_hdr,hdr,rot1
  sxaddpar,hdr,'CTYPE1',strmid(strtrim(sxpar(hdr,'CTYPE1'),2),0,8)
  sxaddpar,hdr,'CTYPE2',strmid(strtrim(sxpar(hdr,'CTYPE2'),2),0,8)

  xyxy, hdr, mhdr, crpix[0], crpix[1], xoff, yoff
  offsets[*,i]=[xoff,yoff]-crpix
 endfor

 cnt = 0 & newzero = [0.,0.]

;sort data into submosaics using WCS offsets
 while cnt lt npm do begin

  odist = sqrt(offsets[0,*]^2. + offsets[1,*]^2.)
  order = sort(odist)
  w = [nmos]
  nw = n_elements(order) - nmos
  if nw gt 0 then begin
   leftovers = (order[w[0]:nf-1])[sort(order[w[0]:nf-1])]
   fnew[*,cnt] = f[order[0:w[0]-1]]
   f = f[leftovers]
   forder[*,cnt] = tmporder[order[0:w[0]-1]]
   tmporder = tmporder[leftovers]
   nf = n_elements(f)
   offsets = [offsets[0,*]+newzero[0],offsets[1,*]+newzero[1]]
   xoffsets[*,cnt] = offsets[0,order[0:w[0]-1]]
   yoffsets[*,cnt] = offsets[1,order[0:w[0]-1]]
   newzero = offsets[*,order[w[0]]]
   offsets = [offsets[0,leftovers]-newzero[0],offsets[1,leftovers]-newzero[1]]
  endif else begin
   fnew[*,cnt] = f
   forder[*,cnt] = tmporder
   f = fnew
   nf = n_elements(f)
   xoffsets[*,cnt] = offsets[0,*] + newzero[0]
   yoffsets[*,cnt] = offsets[1,*] + newzero[1]
  endelse
  cnt = cnt + 1
 endwhile

 odist = sqrt(xoffsets[0,*]^2. + yoffsets[0,*]^2.)
 order = sort(odist)

 f = f[*,order]
 xoffsets = xoffsets[*,order]
 yoffsets = yoffsets[*,order]
 order = forder[*,order]

end
