
pro irac_wcs_fix,infiles=infiles

 if not keyword_set(infiles) then begin
  infiles = dialog_pickfile(/mult,title='Select dithers')
  if infiles[0] eq '' then begin
   print,'Cancelled...'
   retall
  endif
 endif

 f = infiles & nf = n_elements(f)

 bad = intarr(nf)
 for i = 0,nf-1 do begin
  fits_read,f[i],im,hdr,/header_only
  tmp = strtrim(sxpar(hdr,'WCS_SRC'),2)
  if tmp ne 'IWCS' then bad[i] = 1 
 endfor

 wgd = where(bad eq 0,ngd)
 wbd = where(bad eq 1,nbd)
 if ngd eq 0 then begin
  print,'ERROR: no images selected have good WCS refinement!'
  retall
 endif
 if nbd eq 0 then begin
  print,'ERROR: no images seem to have bad WCS refinement!'
  retall
 endif

 uno = f[wgd[0]] 
 fits_datmask,uno,master,mhdr,mmask
 if mmask[0] ne -1 then master[mmask] = median(master)

 f = f[wbd]

 for i = 0,nbd-1 do begin
  fits_datmask,f[i],im,hdr,mask
  if mask[0] ne -1 then im[mask] = median(im)
  offsets = rob_reg(master,im)
  crpix = sxpar(mhdr,'CRPIX*')
  xyad,mhdr,crpix[0]+offsets[0]-1,crpix[1]+offsets[1]-1,ra,dec,/celestial
  sxaddpar,hdr,'CRVAL1',ra[0]
  sxaddpar,hdr,'CRVAL2',dec[0]
  fits_datmask,/write,f[i],im,hdr,mask
 endfor

end
