;+
;
; irac_deband - to take banding out of irac images - needs edge checking.
;
; Rob Gutermuth - 10/22/03
;
;-

function irac_deband,data,xcent,ycent,r0=r0,r1=r1

 if not keyword_set(r0) then r0 = 10. else r0 = float(r0)
 if not keyword_set(r1) then r1 = 15. else r1 = float(r1)
; cent=[81,132]
 cent=[xcent,ycent]

;phase 1, sharp column or row features

 im1z=data&for i=0,255 do im1z[i,*]=data[i,*]-median(reform(data[i,*]),15)

 im1y=data&for i=0,255 do im1y[*,i]=data[*,i]-median(reform(data[*,i]),15)

 sharp = abs(im1y-im1z)

; crap1=[indgen(cent[0]-13),indgen(256-cent[0]-16)+cent[0]+16]
; crap2=[indgen(cent[1]-19),indgen(256-cent[1]-20)+cent[1]+20]
 crap1=[indgen(cent[0]-r0),indgen(256-cent[0]-r0)+cent[0]+r0]
 crap2=[indgen(cent[1]-r0),indgen(256-cent[1]-r0)+cent[1]+r0]

 crap=data*0

; crap[crap1,cent[1]-11:cent[1]+10]=sharp[crap1,cent[1]-11:cent[1]+10]
; crap[cent[0]-7:cent[0]+15,crap2]=sharp[cent[0]-7:cent[0]+15,crap2]
 crap[crap1,cent[1]-r0:cent[1]+r0]=sharp[crap1,cent[1]-r0:cent[1]+r0]
 crap[cent[0]-r0:cent[0]+r0,crap2]=sharp[cent[0]-r0:cent[0]+r0,crap2]
 
 data2 = data-crap

; tvimage,bytscl(data2,min=0,max=400),/keep
; wait,2

;phase 2, smooth column or row features.

; crap1=[indgen(cent[0]-29),indgen(256-cent[0]-31)+cent[0]+31]
; crap2=[indgen(cent[1]-34),indgen(256-cent[1]-33)+cent[1]+33]
 crap1=[indgen(cent[0]-r1),indgen(256-cent[0]-r1)+cent[0]+r1]
 crap2=[indgen(cent[1]-r1),indgen(256-cent[1]-r1)+cent[1]+r1]

 ncrap1=crap1*0.
 ncrap2=crap1*0.

; dedge = cent[1]-18. & uedge = cent[1]+18.
 dedge = cent[1]-r0+1 & uedge = cent[1]+r0

 for i=7,n_elements(crap1)-8 do begin
  for j=0,4 do begin
   if j eq 0 then begin
    tmp1=data2[crap1[i-5:i+5],j+dedge-5]
    tmp2=data2[crap1[i-5:i+5],j+uedge+1]
   endif else begin
    tmp1=[tmp1,data2[crap1[i-5:i+5],j+dedge-5]]
    tmp2=[tmp2,data2[crap1[i-5:i+5],j+uedge+1]]
   endelse
  endfor
  ncrap1[i]=median(tmp1)
  ncrap2[i]=median(tmp2)
;  ncrap1[i]=data2[crap1[i],114]
;  ncrap2[i]=data2[crap1[i],151]
 endfor

; hlp,ncrap1,ncrap2
; stop

 data3=data2

 for i=dedge,uedge do data3[crap1,i]=data2[crap1,i]-median(data2[crap1,i],15)+(uedge-i)/(uedge-dedge)*ncrap1+(i-dedge)/(uedge-dedge)*ncrap2

 ncrap1=crap2*0.
 ncrap2=crap2*0.

; ledge = cent[0]-12. & redge = cent[0]+17.
 ledge = cent[0]-r0+1 & redge = cent[0]+r0

 for i=7,n_elements(crap2)-8 do begin
  for j=0,4 do begin
   if j eq 0 then begin
    tmp1=reform(data3[j+ledge-5,crap2[i-5:i+5]])
    tmp2=reform(data3[j+redge+1,crap2[i-5:i+5]])
   endif else begin
    tmp1=[tmp1,reform(data3[j+ledge-5,crap2[i-5:i+5]])]
    tmp2=[tmp2,reform(data3[j+redge+1,crap2[i-5:i+5]])]
   endelse
  endfor
  ncrap1[i]=median(tmp1)
  ncrap2[i]=median(tmp2)
;  ncrap1[i]=data3[71,crap2[i]]
;  ncrap2[i]=data3[95,crap2[i]]
 endfor

 data4=data3

 for i=ledge,redge do data4[i,crap2]=data3[i,crap2]-median(reform(data3[i,crap2]),15)+(redge-i)/(redge-ledge)*ncrap1+(i-ledge)/(redge-ledge)*ncrap2

; tvimage,bytscl(data4,min=0,max=400),/keep
; wait,2

;phase 3, azimuthal symmetry

; r0 = 15
; r1 = 35

; llc = cent-[30,35]
; sz = [2,cent+[30,33]-llc+1]
 llc = cent-[1,1]*r1
 sz = [2,2*[1,1]*r1+1]
 x = llc[0]+findgen(sz[1])
 y = llc[1]+findgen(sz[2])
 x2 = (x - cent[0])^2.
 y2 = (y - cent[1])^2.

 rdist = data4[x[0]:x[sz[1]-1],y[0]:y[sz[2]-1]]
; ang = rdist
 data5 = rdist

 for j=0,sz[2]-1 do begin
  for i=0,sz[1]-1 do begin
   rdist[i,j] = sqrt(x2[i]+y2[j])
;   ang[i,j] =
  endfor
 endfor

 tmp = r0
 for r=r0,r1+1 do begin
;  for q=0,3 do begin
  w=where(rdist ge tmp and rdist lt r,nct)
  if nct gt 60 or r eq r1+1 then begin
   bad=intarr(nct)
;   if tmp eq r0 then plot,data5[w] else oplot, data5[w]
   ;wait,2
   robomean, data5[w], 1.9, .2, avg, avgdev, sdev, var, skew, kurt, nfinal, good,bad=bad
   if nfinal lt nct then begin
    wbad = where(bad eq 1)
    data5[w[wbad]] = avg
   endif
   tmp = r
  endif
 endfor

 data4[x[0],y[0]] = data5

;spit out result
 return,data4

end
