
;for SIP data

pro irac_mask_fix

 indir = dialog_pickfile(/directory,title='InDir?')
 f1 = findfile(indir+'f*.fits')
 nf = n_elements(f1)
 f2 = findfile(indir+'m*.fits')
 nm = n_elements(f2)
 if nm-nf ne 0 then retall

 outdir = dialog_pickfile(/directory,title='OutDir?')
 file_mkdir,outdir

 for i=0,nf-1 do begin
  tmp = strsplit(f1[i],'/',/extract)
  fname = tmp[n_elements(tmp)-1]
  print,'Processing '+fname
  fits_read,f1[i],im,hdr
  fits_read,f2[i],mask,hdr2
  
  if fix(sxpar(hdr,'ACHANID')) eq 1 or fix(sxpar(hdr,'ACHANID')) eq 2 then begin
   im2 = fpulldown(f1[i],objclip=3,/nofowler)
   w = where(finite(im2) eq 0,bad)
   if bad eq 0 and im2[0] ne -1 then im=im2
  endif

  if fix(sxpar(hdr,'ACHANID')) eq 3 then begin
   im2 = fpulldown(f1[i],objclip=7,/nofowler,hsig=3,lsig=40)
   w = where(finite(im2) eq 0,bad)
   if bad eq 0 and im2[0] ne -1 then im=im2
  endif

  if fix(sxpar(hdr,'ACHANID')) eq 4 then begin
;   im2 = fpulldown(f1[i],objclip=3,/nofowler)
;   w = where(finite(im2) eq 0,bad)
;   if bad eq 0 and im2[0] ne -1 then begin
;    im = im2
;    fits_write,'imf_tmp.fits',im,hdr
;    tnm = 'imf_tmp.fits'
;   endif else tnm = f1[i]
;   im2 = fpulldown2(tnm,objclip=3,/nofowler)
   im2 = fpulldown2(f1[i],objclip=7,/nofowler,hsig=3,lsig=40)
   w = where(finite(im2) eq 0,bad)
   if bad eq 0 and im2[0] ne -1 then im=im2 
  endif

  w = where(mask gt 1000 or finite(im) eq 0 or im lt 0)
  med = median(im)
  mask = mask*0+1 & mask[w] = 0 & im[w] = med

;  im2 = fltarr(396,396)+med & mask2 = im2*0
;  im2[70,70] = im & mask2[70,70] = mask
;  getrot,hdr,rot1
;  im = rot(im2,rot1,/interp,missing=med)
;  mask = rot(mask2,rot1,/interp,missing=0)
  sxaddpar,hdr,'EQUINOX',2000.
  fits_datmask,/write,outdir+fname,im,hdr,mask

 endfor

end
