
pro irac_rot_hdr,oldhd,angle

; getrot,oldhd,angle
 newhd = oldhd
 cdr = !DPI/180.0D

;hacked straight out of hrot, from the GSFC lib

 extast, oldhd, astr, noparams
 if strmid(astr.ctype[0],5,3) EQ 'GSS' then begin
        gsss_stdast, newhd
        extast, newhd, astr, noparams
 endif


 if noparams GE 0 then begin    ;Astrometry parameters exist in header?
    crpix = astr.crpix

    xc = crpix[0]-1
    yc = crpix[1]-1

    cd = astr.cd
    cdelt = astr.cdelt
 
    theta = angle*cdr
    rot_mat = [ [ cos(theta), sin(theta)], $   ;Rotation matrix
                [-sin(theta), cos(theta)] ] 
    
    ncrpix =  transpose(rot_mat)#(crpix-1-[xc,yc]) + 1
    ncrpix = [xc,yc] + ncrpix
    sxaddpar, newhd, 'CRPIX1', ncrpix[0]
    sxaddpar, newhd, 'CRPIX2', ncrpix[1]
 
    newcd = cd # rot_mat

    if noparams EQ 3 then begin     ;Transformation matrix format

        sxaddpar, newhd, 'PC1_1', newcd[0,0] 
        sxaddpar, newhd, 'PC1_2', newcd[0,1] 
        sxaddpar, newhd, 'PC2_1', newcd[1,0]
        sxaddpar, newhd, 'PC2_2', newcd[1,1]
 
                                  
    endif else if noparams EQ 2 then begin

        sxaddpar, newhd, 'CD1_1', newcd[0,0]
        sxaddpar, newhd, 'CD1_2', newcd[0,1]
        sxaddpar, newhd, 'CD2_1', newcd[1,0]
        sxaddpar, newhd, 'CD2_2', newcd[1,1]

     endif else begin  
; Just need to update the CROTA keywords 
        crota  = atan( -newcd[1,0],newcd[1,1] )*180.0/!DPI
        sxaddpar, newhd,'CROTA1', crota
        sxaddpar, newhd,'CROTA2', crota
    
     endelse

 endif 

; if npar eq 2 then oldhd = newhd                ;update old image and header
 oldhd = newhd                ;update old header
 
end
